This file lists the changes made to older versions of
PasswordSafe. The changes for the current version and those
immediately preceding it are noted in ReleaseNotes.md.


Bugs fixed in 3.63.0
--------------------
* [GH966](https://github.com/pwsafe/pwsafe/issues/966) Default font sizes for hi-res displays corrected (Windows).
* [SF1572](https://sourceforge.net/p/passwordsafe/bugs/1572/) [GH959](https://github.com/pwsafe/pwsafe/issues/959) Opening via system tray icon now focuses correctly on Windows 11. The fix was to change the trigger from double-click to a single click, which is consistent with other system tray icons, but is a change for PasswordSafe.
* [SF1565](https://sourceforge.net/p/passwordsafe/bugs/1565/) Dialog box texts in Czech are now rendered correctly (this should also apply to other non-Latin languages).
* [GH946](https://github.com/pwsafe/pwsafe/issues/946) Expiration dates are now the last second of the specified date, instead of the first minute. This resolves a minor inconsistency.
* [GH945](https://github.com/pwsafe/pwsafe/issues/945) Document passphrase parameters in pwsafe-cli.

Changes in 3.63.0
-----------------
* Installer executable now has the "PasswordSafe" icon instead of the default NSIS Icon.
* Latvian is now supported, thanks to Jurcuks.

Bugs fixed in 3.62.0
--------------------
* [SF1570](https://sourceforge.net/p/passwordsafe/bugs/1570/) PasswordSafe no longer crashes when adding a new entry in a filtered view.

Changes in 3.62.0
-----------------
* Text (CSV) import is more lenient in what it accepts, to ease importing data from other password managers.
* When the password is shown, the "Confirm Password:" text is hidden, as the confirmation text
box is used to display the length of the password. Hopefully this makes things less confusing.
* [SF890](https://sourceforge.net/p/passwordsafe/feature-requests/890/) "Recurring" checkbox is now set by default, as this seems to be the more common use-case when setting password expiration in days.

Bugs fixed in 3.61.0
--------------------
* [GH893](https://github.com/pwsafe/pwsafe/issues/893) Removed "Open Another" from system tray menu when a child window (e.g., Add/Edit Entry) is open.
* [SF1566](https://sourceforge.net/p/passwordsafe/bugs/1566/)  Persist Edit Entry and Rename custom shortcuts.

Changes in 3.61.0
-----------------
* [FR906](https://sourceforge.net/p/passwordsafe/feature-requests/906/) Made the ability to browse to an entry's URL with an alternate browser more visible.

Bugs fixed in 3.60.0
--------------------
* [GH883](https://github.com/pwsafe/pwsafe/issues/883) V4: Validation removes orphaned attachments, fixing the database.
* [SF1563](https://sourceforge.net/p/passwordsafe/bugs/1563/) Fixed overlapping controls in Manage->Options->Security tab.
* [SF1560](https://sourceforge.net/p/passwordsafe/bugs/1560/) Flattened list: Width of last column is now retained across invocations.

New features in 3.60.0
----------------------
* [FR904](https://sourceforge.net/p/passwordsafe/feature-requests/904/) Made Edit menu order consistent with context menu (Copy User before copy password).
* [GH887](https://github.com/pwsafe/pwsafe/issues/887) Clipboard history retention is now user-configurable (default off).
* [FR898](https://sourceforge.net/p/passwordsafe/feature-requests/898/) Hovering on a non-empty group icon now shows how many entries under that group.

Changes in 3.60.0
-----------------
* [FR889](https://sourceforge.net/p/passwordsafe/feature-requests/889/) Documented how to work with the Flattened List vew, based on Huw's notes.

Bugs fixed in 3.59.0
--------------------
* [SF1557](https://sourceforge.net/p/passwordsafe/bugs/1557/) Editing special characters in Password Policy works correctly with selected text.
* [SF1553](https://sourceforge.net/p/passwordsafe/bugs/1553/) Text selection in Notes field works correctly (again).

New features in 3.59.0
----------------------
* [SF903](https://sourceforge.net/p/passwordsafe/feature-requests/903/) When an alternativ browser's defined, allow browsing to an entry's URL with it via a new menu option
in addition to the '[alt]' notation in the URL.
* [SF900](https://sourceforge.net/p/passwordsafe/feature-requests/900/) When duplicating an existing entry, the newly created duplicate is selected, making it easier to edit or delete/undo.

Bugs fixed in 3.58.0
====================
[BR1550] Autotype delay now applies to key codes (e.g., &bsol;{Down}) as well as "regular" text.
[BR1549] '-g' command line option now handles UNC path correctly
[GH800] PasswordSafe now prevents data that it places on the clipboard from appearing in the Windows Clipboard History.

Changes in 3.58.0
=================
[FR894] Add support for GoTrust Idem Key 2FA

New features in 3.58.0
======================
[GH785] Added "Open Another" menu item in the system tray popup menu, allowing easy switching to a new PasswordSafe database.

Bugs fixed in 3.57.0
====================
[SF1547] No longer crashes when incremental backup 999 reached.
[SF896] Added \e to ESC mapping in autotype.
[SF1544] Fixed regression in German installer texts.
[SF1539] Workaround touchscreen issue with Manage->Options tabs.

Bugs fixed in non-Windows Release 1.14
======================================
[SF1543] Fixed crash when importing XML with empty password in password history


New features in 3.56
====================
[FR894] Support OnlyKey 2FA

Bugs fixed in 3.56
==================
[SF1542] UNC paths now accepted as backup directory
[SF1530] Maximized window is now restored as such after unlock
[GH737] Fixed crash in 64 bit version when selecting View -> Filters -> New/edit Filter -> Field DCA (or Shift-DCA) followed by Citeria selection
[GH573],[SF1488] "Remind" Windows when PasswordSafe should stay topmost
Fixed Notes line parsing in Run command

Changes in 3.56
===============
[-] Entire password can be selected in password subset display by specifying '*'
[-] Arabic support added


Bugs fixed in non-Windows Release 1.13
======================================
[GH718] Clear YubiSK when Yubi protection is removed.
[SF1536] pwsafe-cli now accepts master passphrases with spaces.

New features in 3.55
====================
Replace the tabs in Manage->Options dialog with a more modern interface.
[SF892] Added tooltip to copy password button in Add/Edit and Password Policy windows.
[SF525] Removed limitation on encrypting/decrypting files larger than 2GB.

Bugs fixed in 3.54.01
=====================

[GH696],[SF1526] Regression: Works again under Windows 7 and 8.
[SF1519] Fixed false change detection due to different line endings.

Bugs fixed in 3.54
==================
[SF1524] Added missing "Show Combination" checkbox to Export Dialogs.
[SF1523] PasswordSafe now displays correctly on high DPI monitors.
[SF1521] In Add/Edit entry's Policy tab, allow lengths to be set when easy vision is selected.
[SF1519] Fixed false change detection when an entry's notes field has > 1 line
[SF1517] Maximized PasswordSafe window is now restored as such.

Bugs Fixed in 3.53
==================
[SF1518] Fixed rare crash after dragging item outside of PasswordSafe.
[SF1504] Fixed regression: lock file is now deleted upon exit.
[SF1030] Incremental search in list view no longer messes up selection.

Changes in 3.53
===============
This is the first release built with Visual Studio 2019 Community Edition and CMake.

PasswordSafe non-Windows release 1.11
=====================================

Fix an issue with the width of spinbox controls in several versions of GTK3 which causes
  spinbox controls to be displayed incorrectly - too wide or too narrow.
  In addition to some heuristics based on the distribution type and version, we allow
  the user control of the width of the spinbox via the PWS_FIX_GTK_SPINBOX environment variable as follows:
  * 0 - This is the same as not setting the environment variable, i.e., let PasswordSafe try to determine the correct width
  * 1 - This lets wx set the width to wxDefaultSize, which may be way too wide for some versions of GTK
  * 2..10 - This sets the width to display this many characters in the text entry field of the spinner.

Bugs Fixed in 3.52
==================
[SF1510] Fixed truncated text in delete confirmation window.
[SF1509] Cancelling a delete now leaves the selection unchanged.
[GH634],[SF1508] Clearing an entry's username no longer causes a revert to default.
[SF1505] No longer crashes when trying to view or copy a shortcut from the "compare databases" results.
[SF1503],[SF1512] Recurring password expiration update fixed ([1497] redo).
[SF1495] Accepts policy name via Enter as well as click on OK.

Bugs Fixed in 3.51
==================
[1497] Changing the password now updates the expiration date if
recurring expiration set.
[1490,G359,G550] Fixed -s switch regression.

New Features in 3.51
====================
[884] Copying password in Edit window of alias entry now copies the
"real" password (that of the base entry).

Bugs Fixed in 3.50
==================
[GH406] No longer flashes main window if user cancels opening screen.
[1496] Easy-to-use password policies now enforces symbol constraint.
[1494] Improve password policy checks and display.
[1491] Workaround 4K monitor display problem.

New Features in 3.49.1
======================
[-] Installaion of pwsafe-cli is now optional in Windows installer.

Bugs Fixed in 3.49.1
====================
[1490,G359,G550] Fixed -s switch (again).

New Features in 3.49.0
======================
[856] Setting the "Copy password to clipboard upon browse" implies copy
password upon Run command.
[-] Added command-line program pwsafe-cli, suitable for scripting.

New Features in 3.48.0
======================
[] Default expiration interval is now configurable via
Options->Password History, instead of being hardcoded to 90 days.

Bugs Fixed in 3.48.0
====================
[1481] Export subgroups correctly.
[1480] Fixed typo in English dragbar tooltip texts.
[1475] Tweak RNG initialization.
[1473] Installer will not create startup shortcut by default when upgrading.
[1243] Installer now selects language support for selected installer language.

Bugs Fixed in 3.47.2
====================
[1468] Reverted clipboard timed clearing function introduced in
3.47.0, as this broke the clipboard functionality on some systems.

Bugs Fixed in 3.47.1
====================
[] Change clipboard clearing delay from 3 to 30 seconds.
[1466] Disable Undo/Redo toolbar buttons when opening database (and
there's nothing to undo/redo).
[GH474] Resized Properties dialog for non-English texts.

New Features in 3.47.0
======================
[862] Last time the master password was changed is kept and displayed
in File->Properties.

Bugs Fixed in 3.47.0
====================
[] Clipboard is more secure - cleared 3 seconds after copied data is
first pasted.
[1465] Removed possibility of not setting Yubikey in changed
passphrase by mistake.
[1453] Fixed regression in tooltip display introduced in fix of BR1449
[1448] Less confusing behavior when the current safe can't be found
upon restore.

Bugs Fixed in 3.46.0
====================
[1458] Fixed compatability issue between Unix and Windows versions
when master password had non-ASCII characters.
[1457] Protect Entry / Group now works when language isn't English.
[1456] Shortcut entries no longer use default username if base entry's
username is empty.
[1455] Ctrl+Enter shortcut now works correctly in read-only mode.
[1454, G411] No longer thinks security preference has changed when it hasn't.

Bugs Fixed in 3.45.0
====================
[G360] (a) System tray icon starts out brown, not green.
(b) Remove system tray icon when cancelling password entry.
[G357] Russian installation text displays correctly.
[1450] Can now generate passwords longer than 94 characters.
[1449] Cleanup statusbar tooltip text.
[1445] Fixed crash on autotype with malformed text.
[1444] Fixed crash in display of Password Policies in Czech.
[1442] Fixed regression: -s flag (silent opening) works again.
[1441] Changing unlock difficulty now enables save (regression),
supported under undo/redo.
[1192] Don't revert to original r-o when locking with an edit box open.

Bugs Fixed in 3.44.0
====================
[1438] Double backslash is now correctly parsed in Run Command.
[1432] Perform autotype of correct entry when the user changes the selection made by a Find.
[1431] The protected entry padlock symbol is now used in all places where a
protected entry is listed in any dialog.
[1430] If an expired or about to be expired entry is edited at database open (requires
warning preference to be enabled), the database will be saved if the 'Save database
immediately after any change' preference is enabled. After the open is complete,
these changes can be undone/redone if required.
[1429] Tree and List views now retain focus when a shortcut entry is created.
[1428] Remember Find toolbar state when restoring from minimized.
[1420] The virtual keyboard font size setting is now persistent.
[1398] Remember if PasswordSafe was maximized when exited.

Changes to Existing Features in 3.44.0
======================================
[] The option that allows you to change the color of the system tray icon
displayed when Password Safe is initially started and when there's no open database
has been removed. The standard PasswordSafe brown icon will be used.
[] Use the Add/Edit font in preference to the Tree/List font outside
the actual Tree/List views (since the Tree/List fonts may be too large).

New Features for 3.44.0
=======================
[] When exporting a group or the results of a filter, if any additional entries have
been exported (e.g. base entries of aliases or shortcuts already exported),
they will be noted in the Export report.
[844] The default font for the password field is now 12pt Consolas.
[843] The default font for Tree/List views, Add/Edit fields and an
entry's Notes is now 10pt Segoe UI.
[842] A new symbol (paperclip - Unicode U+01F4CE) to indicate that an entry has
an attachment (V4 databases only) has been implemented but, if the currently
selected Tree/List font does not support it and the user is not running
Windows 10, then the old symbol ('+') will be used.
[841] Close/exit is now allowed via System Tray icon when the database is open in read-only mode.
[839] The list of expired entries now shows protected entries in
italics, indicating that they must be unprotected before they can be
updated.
[828] The main window can now be set to be partially transparent via
Manage->Options->Display.

Bugs fixed in 3.43.0
====================
[1410] Don't forget '-r' flag when database not found, and needs to be
searched.
[1409] An entry is now correctly re-selected after editing if the preference
"Save database immediately after any change" is disabled.
[1403] Help has been updated to document that an entry's Notes field has a
size limit of 30,000 characters.
[1402] Group image is now correct after dragging an empty sub-group to the next
higher level.
[1400] The Toolbar now correctly disables buttons when a Group is selected.
[1401] After deleting an entry, the next visible entry (if present) is
selected. If not present, then the previous entry (if present) will be selected.
[1399] A disabled image is now shown when no characters to copy are available.
This has also been implemented wherever the "Copy Password" button is used outside
the Toolbar.

Changes to Existing Features in 3.43.0
======================================
[809] Maximum configurable idle timeout increased to 10 hours.

New Features for 3.43.0
=======================
[] You can now specify additional command line parameters to the
external editor used to edit the Notes field from the Add/Edit Basic dialog.
[] It is now possible to export the currently filtered entries to a
new PasswordSafe database.
[832] If many databases are open at the same time, after opening a database, the user
can specify a database index (1-99) that will be superimposed on the System Tray icon
to aid identification. In addition, the System Tray icon tooltip has been enhanced
to show more of the database name.
[833] Right-clicking on a base entry now allows you to select any one
of its dependants, i.e. alias or shortcut.
[834] We've added the option of displaying the safe combination when
entering during database creation, opening and change of combination.

Bugs fixed in 3.42.1
====================
[1404] Regression: In read-only mode, Entry popup menu's View Entry
item restored (was mistakenly disabled).
[1266] Regression: Toolbar elements display correctly on high-resolution monitors
under Windows 8.1 and later now supported in 64-bit builds.

Changes to Existing Features in 3.42.1
======================================
None

New Features for 3.42.1
=======================
None

Bugs fixed in 3.42.0
====================
[] Fix issue when locking database when not using the System Tray.
[] Fix empty group validation on DB open.
[G288] Changes to default password policy now persistent under V4 databases.
[1395] PasswordSafe now correctly duplicates a group containing both a base entry and
its dependent i.e. shortcut or alias.
[1393] Correctly handle opening a locked database, which is open in R/W by another user.
[1392] If the command line parameter '-g' is used to specify a configuration
file by its relative path, PasswordSafe will now look for it in the same
directory as the executable unless overridden by the PWS_PREFSDIR environment
variable.
[1391] Fixed slow opening of a database if the default group display is completely
collapsed.
[1385] The filter active indicator now shows in Windows 7.
[1384] Toolbar images and text are now back in sync.
[1367] Fixed regression in command line arguments -h and -u support.
[1358] When PaswordSafe automatically locks to the TaskBar, the unlock window now gets
input focus when clicking on the icon to unlock the database.
[1346] The Notes window scroll position in Add/Edit no longer jumps to last selected
line when it is reshown after being hidden.
[1275] The scroll positions of the Tree and List views are now saved on minimize and
used to set the window position when it is restored..

Changes to Existing Features in 3.42.0
======================================
[] Previous commands, e.g. edit or delete an entry, are no longer cleared when the database
is locked to enable their undo after the database has been unlocked.
[] User selected font sizes are now saved in points in the configuration file so that the
same size of font is used across different user systems if sharing the configuration file. This
helps where the different systems have different resolutions.
[819] A duplicated entry's creation time is set to the time of duplication.
All other times are copied from the original.
[816] Set installed version in uninstall section of Registry for
Windows version.

New Features for 3.42.0
=======================
[] A new internal filter has been implemented to show only those entries from
last Find. Access via the View menu or Ctrl+K shortcut.
[] PasswordSafe now supports the "long press" as the equivalent of a right mouse click
on Windows systems with touch screens running Windows 7 and later.
[822] An open database can now be locked via the File menu or a Toolbar button
irrespective of whether the System Tray is used or not.
[821] A new symbol for protected entries (locked padlock - Unicode U+01F512)
has been implemented but, if the currently selected Tree/List font does not support
it and the user is not running Windows 10, then the old symbol ('#') will be used.

Bugs fixed in 3.41.0
====================
[] Fix crash if Find active when applying a filter, e.g., show entries with expiry dates.
[] Ensure shortcut is updated in GUI after editing.
[] Text in the Find toolbar search edit control is now vertically centered to
reduce character truncation.
[] Clicking on a field's name copies the value to the clipboard when adding
a new entry (and not only when editing).
[] Update password history when Apply is clicked, not only when Edit
window's closed.
[] No longer show empty groups when the user filters for entries
with expired passwords.
[1378] Fix application crash if Add/Edit entry dialog open when the database is locked
e.g. via idle timer, workstation lock etc.
[1373] An invalid or non-existent backup directory path can no longer be saved
when exiting Options.
[1369] The virtual keyboard no longer becomes unusable after clicking on the
Randomize button.
[1368] The Status bar now shows the correct number of entries when a database
is unlocked.
[1367] Fixed regression in command line arguments -h and -u support.
[1366] Copying the unexpanded autotype string on Edit entry screen using Ctrl+click
on Autotype label now works.
[1365] Ctrl+F now switches focus back to Find toolbar if it is already open.
[1364] Unnecessary tree view refreshes fixed.
[1363] Empty groups no longer disappear when moving nested groups into them and
do not leave duplicated empty groups in the database.
[G192] Saved changes no longer prevent logoff or system shutdown.

Changes to Existing Features in 3.41.0
======================================
[] You can no longer change an alias's base entry's password from the alias entry.
Instead, you should edit the base entry directly by selecting the alias entry and
using the Edit or right-click context menu to select its base.
[] The "Show Find Toolbar" has been removed from the View menu as it appears in
the Edit menu. Ctrl+F still works as before to show the Find toolbar or transfer
focus to it if already visible.
[1371] The font used in the Find toolbar is now set to the user specified Add/Edit
font instead of the Tree/List view font.

New Features for 3.41.0
=======================
[] New AutoType field '\#' toggles the use of the older mechanism to
send keyboard input to other applications e.g. browsers.
[] Add more Help to the Add/Edit Basic and Additional tabs.
[] Empty groups added but not yet saved are now included when the user filters
on unsaved changes.
[] Empty groups, whose names satisfy a filter that include tests on group name
values, are now included in the display when the filter is active.
[815] The database backup location now supports environmental variables e.g.
%homedrive% and %homepath%.  If used, the resulting path is shown.
[814] Clearing the recent database list now requires confirmation.
[813] When exporting a group to a new database, there is now an option to also
export all filters stored in the database to the new database.
[796] Autotype has been extended to support the previous password, if present
in the entry's password history, via the Autotype field '\q'. In addition, for Windows,
a number of keyboard keys are supported by specifying the key between '\{' and '}'. Please
see Help for details.

Bugs fixed in 3.40
==================
[] Correctly import empty groups from a XML file when an imported group has
been specified.
[] Empty groups are now added when merging one PasswordSafe database into another.
[] List view column widths are no longer reset when dragging columns to different
positions or columns are added or removed.
[] The user specified Notes font is now also applied to the Notes column in the
List view.
[] Entry Protected state and AutoType string is now correctly displayed in the
List view.
[] After entry has been edited from List View, it now remains visible after
Edit/Undo/Redo even if the change alters its position within the view.
[1360] When an entry/group using a Named Password Policy is exported to a
PasswordSafe database, the referenced policy is now also exported.
[1355] Fixed tabbing order in Basic AddEdit tab.
[1352] Fixed regression in recent entry processing.
[1347] Prevent a user from trying to copy a filter to a read-only database.
[1346] The Notes window no longer scrolls when re-activated after losing focus.
[1345] Removed the ability to create a new database when read-only is
checked.
[1342, 1343] Fix multiple empty group issues.
[1335] If "Minimize after Autotype" option is set, it will also be honoured for
the user action: "Browse to URL + Autotype".
[1315] Keep selected entry selected after refreshing the view (F5).
[1314] Selected entries keep highlight when the Find toolbar is opened
and even when Password Safe loses focus to another application.
[1313, 1318] Find toolbar no longer closes when it shouldn't. In addition,
results are updated when entries are added/deleted.

Changes to Existing Features in 3.40
====================================
[] Save Immediately has been enhanced to apply to all changes to the database
and not just after an edit or addition of an entry. It is STRONGLY recommended
that, if enabled, then the option to "Create intermediate backups" is also
enabled. Note, changes made via the Compare database results dialog will not
cause a database save for each action but will after the compare results dialog
has been closed.
[] The last sort direction in List View (ascending or descending) on closing
a database is now stored in the application configuration file and is no longer
stored in the database header.
[] The number of groups shown in the database properties dialog is now counted
in the same manner as directories/folders in a file system, e.g.,
Windows Explorer. This includes empty groups. The number of empty
groups is also shown.

New Features for 3.40
=====================
[] Empty sub-groups are included when exporting a group to a new PasswordSafe
database.
[] Adding an empty group will also cause the database to be saved if the user has
selected the option "Save immediately on Add or Edit".
[811] The user's selected Notes font is now used for Tooltips in the Tree and List
views if the Display preference 'Show Notes as Tooltips in Tree & List views' is
set.
[810] Allow font selection for all the user input fields in the Add/Edit entry
and the Create Shortcut dialogs.

Bugs fixed in 3.39.1
====================
[] Fixed a regression that crept into 3.39, breaking non-English
language support.

Bugs fixed in 3.39
==================
[1334] An empty group is now correctly changed to a normal group when
an entry is copied into it via Drag & Drop.
[1330] Duplication of an alias or shortcut base entry now correctly
results in a normal entry.
[1319] Re-implement fix for BR 1319 so that the added entry no longer
appears always selected until the display is refreshed.
[] Export of a complete database to XML now includes all Named Password
Policies.
[] When renaming a group, all empty subgroups are now correctly renamed.
[] Disable switch to read-only when unlocking with changes pending.

Changes to Existing Features in 3.39
====================================
[806] The group will be saved as an "empty group" when the last entry with this
group value is deleted. This is similar to the action of the filesystem when
the last file within a folder/directory is deleted.
[463] Double click on a word in the Notes field, e.g. for copy & paste,
now no longer includes any trailing spaces.  This is different to the
standard Microsoft processing in their products.

New Features for 3.39
=====================
[] Support Drag & Drop of empty groups and groups containing empty
groups between multiple instances of PasswordSafe.  Note: Prior versions
of PasswordSafe will not recognise or process empty groups.
[] It is now possible to list entries using a Named Password Policy from
the Manage Password Policies dialog (right click on the name).

Bugs fixed in 3.38.3
====================
[1334] An empty group is now correctly changed to a normal group when
an entry is copied into it via Drag & Drop.
[1330] Duplication of an alias or shortcut base entry now correctly
results in a normal entry.
[1319] Re-implement fix for BR 1319 so that the added entry no longer
appears always selected until the display is refreshed.
[] Export of a complete database to XML now includes all Named Password
Policies.
[] When renaming a group, all empty subgroups are now correctly renamed.
[] Disable switch to read-only when unlocking with changes pending.

Changes to Existing Features in 3.38.3
======================================
[806] The group will be saved as an "empty group" when the last entry with this
group value is deleted. This is similar to the action of the filesystem when
the last file within a folder/directory is deleted.
[463] Double click on a word in the Notes field, e.g. for copy & paste,
now no longer includes any trailing spaces.  This is different to the
standard Microsoft processing in their products.

New Features for 3.38.3
=======================
[] Support Drag & Drop of empty groups and groups containing empty
groups between multiple instances of PasswordSafe.  Note: Prior versions
of PasswordSafe will not recognise or process empty groups.
[] It is now possible to list entries using a Named Password Policy from
the Manage Password Policies dialog (right click on the name).

Bugs fixed in 3.38.2
====================
[1326] Fixed entry corruption when database locked/unlocked while an
entry was being edited (and possibly other scenarios).
[] Ensure that the Tooltip on how to unprotect an entry is now shown
against the tutorial text at the top of the dialog for wide displays.
[1319] Newly added entries are now shown as selected in the Tree view.

New Features for 3.38.2
=======================
None

Bugs fixed in 3.38.1
====================
[] Fixed regression in alias support
[] Fixed regression: crash in Linux when incorrect password entered
[] Fixes in advanced find report
[] V4 (alpha) related fixes
[] Fixes related to empty groups
[1312] Now able to duplicate an alias entry without errors.
[1306] Display of an empty group is now correctly displayed when an entry
is moved to it via editing.
[1295] Create Shortcut group dropdown box width no longer truncates long
group paths.
[1057] Aliases and shortcuts imported via XML now correctly point to their
respective base entries.

New Features for 3.38.1
=======================
[797] Change the Add/Edit dialogs to allow a larger Notes field to be
visible.  Protected entries now only have this information in the dialog
caption. The Tooltip on how to unprotect an entry is now shown against the
tutorial text at the top of the dialog.

Bugs fixed in 3.38
==================
[1289] Uniform behavior for generated password: Can be explicitly
copied to clipboard whenever generated (no longer copied by default).
[1266] Toolbar elements display correctly on high-resolution monitors
under Windows 8.1 and later.

New Features for 3.38
=====================
Experimental support for V4 format. DO NOT USE FOR PRODUCTION ("REAL")
PASSWORDS.

Bugs fixed in 3.37.1
====================
[] Fixed crash when adding/editing an entry with wide version of
dialog.

New Features for 3.37
=====================
[] The Notes External Editor now accepts environment strings (e.g. %windir%)
in the path to the editor.
[789] If the double-click action (or shift-double-click) of an entry
is set to Edit/View Entry, then (shift-) double-clicking on its
shortcut will edit/view the base entry. The selected shortcut entry
can still be viewed/edited via menu, right-click or just hitting Enter.
[782] Notes field font is now user-configurable.
[781] Virtual Keyboard - allow playing sound when a valid or invalid key
is pressed and add caption to the Space Bar (Partial implementation of
this Feature Request).

Bugs fixed in 3.37
==================
[1274] References to base entries are now scrollable, no longer
truncated.
[1273] Find in the Tree View will now ensure that any found entry will be
visible by scrolling appropriately.
[1272] XML export of single entry using default Password policy now
works correctly.
[1270] Display Filter dropdown list of filter fields now fits on low
resolution screens.
[1269] Filters containing Password Policy Names now export/import
correctly to/from XML.
[1267] Export from a YubiKey-protected database to another database
fixed.
[1261] 'Unlock Difficulty' slider is now correctly initialised in the Manage
Options Security tab.
[1260] If Password Safe is unable to find the user specified external editor,
the external edit is cancelled and the Notes field remains unchanged.
[1258] Group dropdown box width no longer trucates long group paths.
[1254] Toolbar customisation now has correctly aligned text/images.
[1244] Changes to symbol set in default password policy are respected
when "Use easy-to-read characters" is set.
[1230] "Open as read-only" check-box correctly set when opening a R/W database
after previously opening/selecting a R-O database.
[1204] Show correct icon color in system tray when unminimizing with
no database open.
[1124] Autotype on a shortcut entry now picks up title, group and user
fields from shortcut instead of base.
[1082] Field modification times set to creation time for list view and
entry's time and date tab. This is more useful than "N/A", e.g., for
sorting by password modification to find old passwords that should be
changed.
[1054] Password Variable in Run Command correctly set when executed from an alias.

New Features for 3.36
=====================
[] Entries and Groups can be exported to plain text, XML, or to a new
PasswordSafe file.
[777] Added command line option to force choice of tall or wide dialog screens.
[772] Added a tooltip for the copy-to-clipboard button in the generator.
[768] Caps Lock indicator added to passphrase entry dialogs.

Bugs fixed in 3.36
==================
[1248] Non-ASCII symbols can now be specified in Password Policies.
[1245] Asterisk is now accepted as a symbol in Password Policies.
[1233] Don't count unchecked character types in password policies when
checking for consistency.
[1231] Relax restriction on easy-vision password policy + more
consistent UI.
[1229] Hex digits checkbox can be selected in Generate Passwords.
[1228] Fixed incompatability with Password Policies generated with
previous versions.
[1226] Fixed regression in Find toolbar functionality.

Bugs fixed in 3.35
==================
[1221] Support newer YubiKeys in all modes.
[1212] In the Flattened List view, keep the icon column, if present,
as leftmost, to ensure proper display.
[1211] The Read-Only checkbox no longer clears itself after returning
from the file selection dialog. Also, the read-only checkbox in XP
file selection dialog is handled correctly.
[1210] CurrentFile preference is updated sooner rather than later, so
last database is set as default for next invocation.

Changes to Existing Features in 3.35
====================================
[760] Password Policy: You can now choose a character set without
requiring at least one character from that set (i.e., minimum required
can be zero).

New Features for 3.34.1
=======================
[753] A Password Safe database can be opened by drag & drop to the
Password Safe application window.
[749]   Clicking or double-clicking on a previous password in an entry's
Password History selects it.
[746]   Password Policy "Special Symbol Set" simplified.

Changes to Existing Features in 3.34.1
======================================
[397] Clarified use of -g and PWS_PREFSDIR.

Bugs fixed in 3.34.1
====================
[1205] 3.34.1 fixes a bug that crept into 3.34: The OK button was
disabled when a database was selected on the opening window.
[1200] Tweak Yubikey interface to make it easier to use when creating
or opening a Password Safe database.
[1195] Edit->Find now enabled when a group is selected.
[1194] Compare, Merge, Sync: Enable action button when password's
entered via virtual keyboard.
[1176] Tweak definition of what's considered a 'weak' password.
[1174] "Open as read-only" check-box now correctly reflects the file's state.
[1117] Dragging dropbar icon doesn't copy text to clipboard unless
Control key's pressed when icon's clicked upon.

New Features for 3.34
=====================
[753] A Password Safe database can be opened by drag & drop to the
Password Safe application window.
[749]   Clicking or double-clicking on a previous password in an entry's
Password History selects it.
[746]   Password Policy "Special Symbol Set" simplified.

Changes to Existing Features in 3.34
====================================
[397] Clarified use of -g and PWS_PREFSDIR.

Bugs fixed in 3.34
==================
[1200] Tweak Yubikey interface to make it easier to use when creating
or opening a Password Safe database.
[1195] Edit->Find now enabled when a group is selected.
[1194] Compare, Merge, Sync: Enable action button when password's
entered via virtual keyboard.
[1176] Tweak definition of what's considered a 'weak' password.
[1174] "Open as read-only" check-box now correctly reflects the file's state.
[1117] Dragging dropbar icon doesn't copy text to clipboard unless
Control key's pressed when icon's clicked upon.

New Features for V3.33
======================
[728]	The default delay between characters on autotype is now configurable.

Bugs fixed in V3.33
===================
[1160]	Don't create config dir if config file passed in command line.
[1155]	Number of shortcuts is now correctly initialized.
[1148]	No longer crashes when canceling unlock with expired password entries.
[1146]	Edit button now enabled correctly in Manage->Password Policies.
[1139]	Backup file numbers now rollover 999 correctly.
[1134]	Filtering by type now works correctly for shortcuts & shortcut bases.
[1130]	Database field isn't highlighted when it doesn't have the focus.
[1125]	Increased range of unlock difficulty by a factor of four. This should give an order or magnitude or so between max and min settings.
[1067]	Fail gracefully when trying to encrypt a file > 2GB.

New Features for 3.32
=====================
[705] User can choose not to let PasswordSafe record which virtual
keyboard was used.
[703] Changing a database opened in read-only mode to read/write will
revert when the database is locked.
[695] Allow a keyboard shortcut to be associated with selecting an entry.
Please see Help entry for more details.
[] Add setting to configure the amount of processing required to save and
open a database.
[] Support Yubico's YubiKey authentication token. Previously this
product was supported in a separate branch.

Changes to Existing Features in 3.32
====================================
[718] Run command can now accept $e or $email and will expand this to
the entry's e-mail.
[] Add validation of entry field XML characters to ensure resulting file
can be imported.  Note: any field containing an invalid character will not
be exported and a comment added to the export file and the report.

Bugs fixed in 3.32
==================
[1124] Copying the username of a shortcut entry now works correctly.
[1122] -d dialog no longer needs password verification.
[1121] Help now displays correctly for Import XML settings.
[1113] Filters now handle empty fields correctly.
[1108] Manage Password Policy lists and Edit Entry's Notes fonts are
set to same as for main list/tree, user-configurable.
[1101] Autotype email and url now works with shortcut.
[] Prevent Alt+Enter or Ctrl+Enter when setting the Application Hotkey in
PasswordSafe options dialog closing the dialog and saving an invalid Hotkey.
[] Support wrap scrolling in the ListView using up and down arrow keys.

New Features for 3.31
=====================
Turkish translation added, thanks to Yusuf.

Changes to Existing Features in 3.31
====================================
[698] Autotype now supports URL and email fields with \l and \m,
respectively.
[673] Improved selection of subset of password: characters can be
specified from the end of the password as well as from the beginning
(thanks to DK).

Bugs fixed in 3.31
==================
[1097, 1098] Fixed typos in format description text and in English online help (thanks to PeterHB)
[1096] Correct suffix appended to proposed filename when exporting to XML.
[1095] Ampersand (&) is handled correctly in Password Policy (thanks
to Andrey)
[1092] Compare DB results context menu items now enabled correctly in
Read Only (thanks to DK).
[1085] Preferences that are stored in the database are colored blue
again (thanks to DK).
[1086] Unknown database preferences are preserved (thanks to DK).
[1081] Minor issues related to password policy options.
[1079] Password history date is now displayed in locale's format in
entry's Additional tab.
[1078] Expand entry's autotype value in Run Command's $a parsing.
[1077] Don't report URL as copied to clipboard when it isn't.
[1068] Opening a protected entry no longer causes a sound in Windows.

New Features for 3.30
=====================
[689] It's now possible to change the r/w state of a database when
unlocking it. Thanks to Jeff for the suggestion.

Changes to Existing Features in 3.30
====================================
None

Bugs fixed in 3.30
==================
[3556730] In Add/Edit dialog, clicking Apply no longer disables the OK
button. An asterisk (*) is displayed in the title bar when the entry's
modified and Apply's not clicked upon. Thanks to shivak7 for the fix.
[3539347] An empty diamond icon is now updated to a full one when an
entry is dragged into it. Thanks to nsaipraveen for the fix.
[3537861] An off-by-one issue with expiration dates has been fixed by
suthakar123.
[1066] Default changed: 'Browse to URL' does not copy password to
clipboard by default. Although convenient, this is a security issue if
the user isn't expecting it. Also show correct screen in Security
Options help.
[1065] Don't hide notes in Add/Edit dialog box when changing field
focus if user chose not to.
[1063] Intermediate backups also work correctly when relative path to
database is specified on command line. Thanks to Matt for tracking
this down.
[353] Easy-to-read option now respected in Generate Password screen.
[] Update ListView immediately when an entry's field has been changed.

New Features for 3.29
=====================
[3519484] Empty Groups are now persistent (previously a group with no
entries would 'disappear' if the database was locked or closed).
[3510481] The Last Modified and Password Modified date/times are
initially set to show the entry's creation time, instead of being blank.
[] When comparing databases, you can now display of the details of the
entries' differences in the results dialog by right-click -> compare
selected entries.
[] You can now cancel a long running Compare, Merge or Synchronize
database operation. Note: You should check the operation's report file
to see if the operation was indeed cancelled. If not, you can undo it
as all operations).
[] Portuguese (Brazil) installation instructions added, thanks to Andreas.

Changes to Existing Features in 3.29
====================================
None

Bugs fixed in 3.29
==================
[3525995] Find now only highlights/select the found entry.
[3523117] Password Expiration Date now correctly set when using intervals.
[3521158] Paste into the Notes field (Add or Edit entry) is now always
in plain text.
[3518734] When generating passwords (Ctrl-P), the user is no longer
prompted to save changes when pressing Esc if they have selected a
Named Password Policy but not generated a password.
[3518732] Custom special symbol set now handled correctly in Generate
Password dialog box.
[3518389] All date/time fields in the List view are now displayed
using the user's "short date" format as specified via the Windows
Control Panel "Region and Language" tab.
[3515692] Fixed crash with Generate Password switching to default
policy with > 1 named policy.
[3514819] Add Group now works again.
[3510590] Password History is now correctly repaired during the
automatic Validate on database open. 
[3508891] Editing an entry's Notes using an external editor no longer
adds blank lines and fully supports non-Latin characters.
[3498625] Test selected password policy now reflects any edits done to
the policy.
[3495473] Notes Word Wrap during edit now works again.

New Features for 3.28
=====================
[3468289] The passwords in the Password History and in the List view now
displayed with the specified Password Font. In addition, you can now zoom
in and out of the Notes field, for easy reading of texts.
[3455436] The password history can now be deleted for all existing entries
in a database at once (optionally including Protected Entries).
[3421963] Multiple Password Policies can now be defined, managed and
selected in entries to generate passwords.
[] Partial support for Czech has been added, thanks to butchtik.

Changes to Existing Features in 3.28
====================================
[3445820] The Edit menu item and entry right-click context menu item "Copy Run Command to
Clipboard" will now substitute any variables within the command. This can
be disabled by holding down the Ctrl key when selecting these menu
items. (Note that the standard menu shortcut can't be used to disable, as
the Ctrl key may be used to select a different menu item/command.)
[] As mentioned in the V3.26 release, the XML representation of date/time
fields, are now in the W3C dateTime standard format instead of PasswordSafe's. This release
no longer supports import of XML files with date time fields in the old PasswordSafe's format.
See the online Help (the XML section of "Import Password Entries") if you
need to manually convert old XML files.
[] After closing the current database, on opening another, PasswordSafe will first
attempt to access the directory of the last opened database in order to allow the user
to start browsing for their intended database.  If this directory is not available,
PasswordSafe will open the default "My Safes" directory as it did prior to this change.
[] Databases are now always validated when opened. The Manage->Validate
menu item has therefore been removed.
[] The default backup policy has been changed to save the last three
versions of the database, instead of one. 
[] The graphic symbols for entries, groups, etc. have been redone, as most
displays now support more than 256 colors.

Bugs fixed in 3.28
==================
[3486960] Rename of a group is now complete even if a filter is active.
[3486959] PasswordSafe no longer crashes when returning to edit after lock.
[3468853] The number of saved passwords can be changed and after the user presses Apply
they will no longer be warned that the entry has been changed when pressing Cancel.
[3462520] A password entry's expiry time in days now correctly reflects the
expiration date for non-recurring expiration.
[3440318] Filters can now be cleared by double-clicking on the filter indicator in
the status bar. Also, Filter Menu correctly changed when a filter is active.
[3435869] '-g config_file' option now accepts a non-existing file, creating
it after notifying the user.
[3430196] Buttons in the Options property pages now retain the user's Windows theme.
[] Fix inability to copy entries to the original database in the Compare database results
dialog.
[] Thanks to Jon F. for proofreading the online help.

New Features for 3.27
=====================
[3367590] User can now add a database name and description via the Properties
dialog.
[3349458] Allow filters to match on rules based on the password's length.
[3316779] Shift + "left mouse button 'Double-Click'" now configurable for user.
Default is copy the username to the clipboard.
[] Preferences stored in the database are shown in blue in the Options dialogs.

Changes to Existing Features in 3.27
====================================
[3406549] Tooltip for System tray (displaying database file path) is
now limited to 40 characters (replacing text in the middle with '...'
if needed).
[3348954] The passphrase is now required to change from read-only to
read/write.

Bugs fixed in 3.27
==================
[3411210] No longer crashes when unlocking with Subset Password dialog
box opened.
[3395549] PasswordSafe now displays forms correctly on Netbooks.
[3382422] Toolbar now updated to reflect R/W or R-O mode when user
dynamically changes mode. 
[3380714] User can now save database after manually taking a backup.
[3380424] System Menu 'X' now closes the Edit/View PropertyPages when
the database is in R-O mode or the entry is protected.
[] Filter image in Status bar is no longer replaced by 'Filter1' after
changing preferences via Manage->Options.
[] Selecting hexadecimal passwords as the database policy no longer
causes validation to fail.
[] Correctly show database has been modified (to allow saving) if
database preferences have been changed.

New Features for 3.26
=====================
[3288341] Autotype has been added to the DragBar. Drag the image to an
input area on another Window (e.g., Browser) and PasswordSafe will
begin Autotype from there. 
[3286721] User can now toggle between read-only and read-write modes
via a menu item or by double-clicking on the current R-O or R/W
indicator in the Status Bar.
[3203152] The displayed language can now be changed via the new
Manage->Change Language menu.
[3065111] Add/Edit now displays both the Application's (PasswordSafe) and the
current database's default Autotype string (if set via Manage->Options).
[2964804, 1855389] The user can specify the list of symbols valid for
password generation, and can override this for any particular
entry (except when EasyVision or Pronounceable passwords are chosen).
[1831893, 1471134] Added Autotype code "\s" to send "Shift+Tab" (back tab).
[] Allow user to control copying of the password to clipboard when
performing "Browse to URL" via an option in Options->Security. This is
a database option i.e., you can have different setting for different
databases.
[] Support importing of TXT, CSV files and XML exported from KeePass
V1 and KeePass V2 XML files. Note that KeePass V2's export in the V1
format is does not conform to their own format as specified by their
V1 product and can not be imported. Please review our Help file for
the settings in KeePass required during their export. 

Changes to Existing Features in 3.26
====================================
[] New image on start-up dialog - courtesy of user Prinz_Eugen.
[] Polish installation texts added thanks to Michal Niklas.
[] An entry's password expiry date is set or cleared directly rather than using
the Set and Clear buttons after changing values.
[] The default password generation policy is now for 12 character
passwords that include symbol characters (previous default was 8, no
symbols).
[] Unknown database header fields and unknown entry fields are no
longer exported when a database is exported to XML as there is no
mechanism to re-check them during import. Exporting to XML and then
importing to a new database can be used to remove these unknown
fields.
[] Date time fields, when exported to XML, now are in the W3C dateTime
standard format instead of PasswordSafe's.  This release can import
XML files with date time fields in either of these forms. The next
release will only be able to process the W3C standard.
[] Fully support importing of TXT files exported from KeePass V1
including the Group Tree structure, URL and date time fields. Please
review the online help for more details.

Bugs fixed in 3.26
==================
[3325116] Users can no longer select an entry via the System Tray
icon's Recent Entry menu if the display has not been restored after
minimize or unlock.
[3306357, 3062632, 2888026] User preference changes are now correctly
saved. This includes allowing user to change database preferences when
the database is read-only.
[3303018] Filters with quotes in their name are now correctly
exported, imported and displayed in the Manage Filters dialog.
[3301904] Export XML, export Text and the export of filters functions
now process file names and paths containing non-Latin characters.  In
addition, missing directories in the specified path are created as
neeeded.
[3234204] PasswordSafe no longer exits if the command flag is set to
"-s <databasename>".
[3088187] The correct entry in List View is now used for Autotype when
using the keyboard to select the entry when PasswordSafe first opens.
[] Controls in Edit are now disabled if entry is protected.
[] Compare databases now correctly compares the 'Protect' and password
policy 'symbols' fields of entries.

New Features for 3.25
=====================
[] Dutch installation instructions thank to Kees, and a first
(incomplete) Dutch translation of the application thank to Bert, Kees
and Fred.
[] Korean texts in the application and installer program thanks to
Seunggyun.
[] Poserpro has provided Traditional Chinese texts for the installer
program.
[] New View menu option: Show entries with Expiry. This is useful for
displaying entries with passwords that are expired or about to expire.

Changes to Existing Features in 3.25
====================================
[3171962] The password expiration warning mechanism now checks for
expiration daily. The display of expired and almost-expired entries
has been redesigned, allowing users to update the entry directly. When
an expired password is changed, the expiry date will be cleared unless
there is a recurring password expiry interval, in which case a new
expiry date will be calculated.
[3131945] Double-clicking on the system tray icon when PasswordSafe is
not minimized now brings it to front, instead of minimizing.
[3131935] Rename of an entry or group in the Tree View can now only be
performed via the Rename shortcut (default value F2), using the Edit
menu or the right-click context menu. Edit in place by double clicking
the entry is no longer allowed as, most of the time, this was not the
desired action.
[] Filtered views are now updated when an entry's edited, e.g., if an
entry is edited such that it no longer satisfies the filter's
criteria, it will be removed from the display. 
[] The Russian online help has been totally rewritten and updated,
thanks to pm_kan.
[] pm_kan has updated the Russian texts.
[] The Spanish texts have been updated thanks to Jose.
[] Karlo has updated the German texts.
[] Francois has updated the French texts.
[] Bjorne has updated the Swedish version.
[] Freedoctor has updated the Chinese texts.

Bugs fixed in 3.25
==================
[3194472] Fix new group creation location. When a Group is selected, then
selecting 'Add Group' from the Edit menu or from the context menu
displayed by right clicking on that Group, the new group will be a
child of the selected group. However, when using the context menu
displayed on right clicking on 'white space' below the last
entry/group displayed, the group will be created at the topmost
level. 
[3165889] No longer crashes if search starts with Shift-Enter (search
backwards).
[3148701] Windows installer will now refuse to install on Win2K,
referring user to last supported version on that OS (3.18).
[3115760] Window view is now saved and restored if the user uses the Windows
"Show Desktop" feature.
[] No longer crashes when doing an Undo after a Merge.
[] Ensure Undo/Redo honour the changes to the display of the original change.

New Features for 3.24.1
=======================
[] Allow an entry to be protected against modification even if the database
is opened in read-write mode. See 'Basic Tab' in Edit dialog. In Tree mode,
a number sign (#) after the name indicates the entry is protected. In
List mode, the 'Protected' column may be added to the list. A
protected entry can not be edited, renamed or deleted and retains this
property if Dragged & Dropped onto another database.

Changes to Existing Features in 3.24.1
======================================
None

Bugs fixed in 3.24.1
====================
[3132055, 3132347] Fix crash in V3.24

New Features for 3.24
=====================
[3111585] User can now duplicate Groups. Aliases and shortcuts referring to base
entries outside this group will still point to their respective bases. Those
referring to base entries within the group will then point to the new copy.
[3065107] Confirm Delete dialog for an entry now shows the entry's details.
[3062854] Advanced Dialog Options settings are saved for a session to allow
re-use. The following functions use the this dialog and their settings are saved
separately: Merge, Compare, Export to Text, Export to XML, Synchronize and
Find Toolbar.
[3062809] Add "Add Group" to Toolbar.
[3062788] Add "Add New Entry" menu item to additional context menus.
[] Online help is now available in Spanish, thanks to Jose.

Changes to Existing Features in 3.24
====================================
None

Bugs fixed in 3.24
==================
[3121006] Can now change number of databases remembered independently of the
value of the number of last used entries remembered in System Tray menu. 
[3084401] When database is locked, clipboard is cleared and the hotkey works.
[3069250] PasswordSafe now remembers the selected entry on Lock After Idle.
[3065827] Uninstall fails gracefully when invoked with pwsafe running.
[3062850] Dialogs are now correctly closed if open when the workstation locks
(with preference "Lock password database on workstation lock" set), enabling
the application to be opened again.
[3062769] Groups list in Add/Edit dialog box no longer "remembers"
groups from previously opened database.
[3058043] Hexadecimal password policy now correctly saved.
[] Spanish translations for installer and application updated - thanks
to Jose.

New Features for 3.23
=====================
[3022827] Implement 'stealth' mode where, as long as the user specifies both
the use of the System Tray and a valid Hot Key, then the System Tray
icon and the button on the Taskbar can be hidden.
[3017535] Allow user to edit the generated passwords (Manage->Generate Password)
before copying to the clipboard.
[3011546] "autotype" can now be added to the List View via the Column
Picker (right click on column labels).

Changes to Existing Features in 3.23
====================================
[3026944] Confirm on Delete option has been re-instated.

Bugs fixed in 3.23
==================
[3029576] Ensure user specified backup directory ends with a slash.
[3028926] Entries modified via Synchronize are now displayed correctly if the
user checks the preference "Highlight changed entries" via Options->Display.
[3016803] No longer crashes when trying to view a base entry with
similarly named aliases.
[3013199] PasswordSafe no longer hangs when trying to read preferences
stored in registry by older versions.
[3011972] By adding more checking when creating the menus for Recent Entries
off the System Tray menu, prevent crashing when clicking on the icon.
[3010926] Can now set a non-recurring expiry date using the calendar during
Add/Edit.
[3010541, 3013981, 3011972] Fixed crash when locked and the user
right-clicks the System Tray icon.
[3009130] Changes to an entry's password policy are now saved upon OK or Apply.
[3008203] The password expiration date is now automatically updated when
a "recurring" password expiration is set and the password is changed.
[3006125] Selected entry/group before database is locked or minimized,
including when Windows goes into Standby/Hibernate is now re-selected when
the database is later displayed.
[3006069] Autotype now works correctly when the user specifies that
PasswordSafe should minimize after Autotype and has also set that the
database should be locked on minimize.
[2957038] Cursor no longer disappears when PasswordSafe thinks that the
user is dragging an entry but then doesn't.
[] The Save Toolbar button and the Save menu item are now correctly
enabled if the user changes preferences saved in the database.

New Features for 3.22
=====================
[2983775] Recently Used Entries are now saved in the database header and
so are "persistent".  The current Windows user interface limits this to a
maximum of the last 25 entries accessed.
[2980609] Allow date filters to use relative dates
[2979411] A single entry can now be exported to a text or XML file via the
Edit menu or right-click context menu.
[2957185] Add Synchronize function to the menu options during review of
the results of a Compare database operation.
[] Support for Danish has been added - thanks to Rejmond for his
effort in translating!
[] Validation of databases can now be performed via the Manage menu as
well as via the command line flag '-v'. When executed via the menu, it
is very similar to opening a new database in that the current open database
is closed and the selected database is validated during the open process.
[] Allow user to select external editor for Notes field in Add/Edit dialog.
[] Add entry size to the available filters to be able view entries.
[] Warn users during database open and entry import if there are entries
with large text fields (e.g. Notes) that cannot be fully displayed and may
be truncated if edited.

Changes to Existing Features in 3.22
====================================
[] Preferences are now saved in the 'normal' per-user directory under
Windows. Existing installations will use current preferences, but
users can migrate to the new location via
Manage->Options->System->Migrate PasswordSafe configuration to user
directory.
[] New databases will be created by default in "My Safes" directory
under "My Documents".

Bugs fixed in 3.22
==================
[3004446] Deleting a group of entries works again.
[2994118] Swedish version no longer crashes when checking for latest
version.
[2990734] Changing either whether password history is kept and deleting
currently saved history now activates the OK Button.
[2990609] Clicking to rename entries is now disabled when database is read-only.
[2984527] Database preferences (including the Idle Timer setting) now retained
during a locking minimize to the System Tray.
[2977941] The password expiry date is now updated during edit if the password
is changed either via the Generate button or by the user manually editing it.
[2977045] Can now make password expiration date any value from the current
date.
[2962916] Save toolbar button only enabled if database is R/W and has been
changed since last saved.
[2962847] Fix password length checking to be between 4 and 1024 during
menu Generate Password option & Password Policy setting as per previous
releases.
[2960709] Entry selected prior to workstation locking is reselected on
being restored after unlocking the workstation.
[2957933] Ensure that AutoType delay and wait times are not impacted by numeric
characters from any entry field substitution.
[2951871] Shortcut related menu items now returned to the Edit menu and
the "Run Command", "Browse to URL", "Browse to URL + Autotype" and
"Send email" functions now work again, when a Shortcut entry is selected.
[2897661, 2779654] Group expand/collapse state restored after the database
is Locked, Minimized or "AutoType with Minimize" and then Restored.
[] Use of External Editor on Notes field from Edit dialog now activates Apply
and OK buttons.
[] Fix errors if importing an XML file with entries with duplicate unique IDs
(UUID elements).
[] Remove "Confirm Deletion of Entries" checkbox from theMisc. Options
page. New support for Undo/Redo made this unnecessary. Users are always 
asked to confirm the deletion of Groups or entries that have aliases or shortcuts.

New Features for 3.21
=====================
[2940756] Add "Apply" button to Edit property pages so that
intermediate changes can be saved without closing the Edit property pages.
[2919319] PasswordSafe can now be used as a password generator via the
Manage menu.
[2616175] Allows user to retry finding the original database if not
successfully found the first time.
[] Undo/Redo of changes to the currently open database. Any change to
the database can now be undone and redone, as long as the database is
open. This is similar to the undo/redo feature available in most word
processors, and is activated the same way (Ctrl-Z for undo, Ctrl-Y for
redo, or via the Edit menu).
[] New Synchronize feature (subset of the current Merge function) to
allow changes in the fields of entries of two databases to be
synchronised.  Entries with identical Group names, Titles and User
names are compared when syncing. The database selected to be
synchronised with the current open database is now always in read-only
mode i.e. Synchronisation is uni-directional and only entries in the
currently open database can be modified.

Changes to Existing Features in 3.21
====================================
[] When comparing databases, the "other" selected database is now always
opened in read-only mode.

Bugs fixed in 3.21
==================
[2941828] In Add & Edit, changes to the Password Policy take effect
immediately; pressing the Generate button will create a password
according to the new policy, without having to save and re-open the
entry.
[2940712] Dragging a group now drags along all its descendants.
[2931428] Password history now displayed correctly in View/Edit.
[2918306, 2816066, 2798788, 2446052, 2837591, 2917066, ...] Re-instate
AutoType via shortcut and when an entry has been selected via the 
Find Toolbar.
[2921935] Dragbar now works in List view without needing the mouse to activate.
[2918849] Fixed icon no longer appearing in taskbar when locking due to
workstation lock and terminal services running.
[2916338] "Edit Base entry" now works for Alias entries as well as for Shortcuts.
[2913440] Copy/Send Email menu items now correctly activated if email field
is set or 'mailto:' used in URL field.
[2912177] Adding Groups via right-click menu now works again under
default configuration.
[2894100] PasswordSafe window no longer creeps down the screen if the Windows 
taskbar is at the top of the screen.
[2818401] AutoType backspace field ('\b') now honoured in both "AutoType" and
"Browse To + AutoType" consistently.
[2431438] When unable to find a previous database via the recently opened databases
on the File menu and the user is given the option to open a different database or
create a new one.
[1751462] After Find Toolbar Advanced dialog is used, the previous Find results
are now reset.
[] Finally fix issues running under pre-XP versions of Windows.
[] Fix issue when changing the displayed columns in List View and then switching
to Tree View.

Bugs fixed in 3.20
==================
[2906249] User changes to List view's column order are now persistent.
[2905961] ESC key now works correctly in View Entry when in RO mode.
[2873106] Export XML warnings now consistent with Export Text's.
[2872829] Duplicating an entry now copies the password policy as well.
[2872602] Preferences are now correctly deleted from the Windows registry
if they match the default (when registry is enabled).
[2870059] When an entry is highlighted during Find, the Toolbar and menu
items now reflect its contents.
[2868278] Minimize via the system menu, SystemTray menu and system control
box button now locks the database if the preference 'Lock on Minimize' is
set.
[2868244] Change font dialogs now work again.
[] Import from a text file with non-Latin text now works correctly.
[] No longer complains about WTS service in pre-XP versions of Windows.
[] Filters containing tests on the entry type are now correctly
exported to XML.
[] Validate of Password History (-v command line flag) now removes
history fields with invalid dates or empty old password fields.
[] Fix match test 'does not begin with' - used in filters and restricting
entries exported to Text or XML.
[] Fixed icons display in List view.

New Features for 3.20
=====================
[2895167] Dragbar tooltips changed to provide relevant information for each
image and reduce the amount of text.
[2881604] Allow edit of base entry of a shortcut via the Edit menu and/or
by right-clicking on a shortcut entry.
[2872273] Improve Import Text 'Line skipped' message.
[2826509] Can now update passwords of existing entries via Import Text or XML:
  For Text import, the 'Group/Title', 'Username' and 'Password' fields
  are required. 
  For XML import, the Title and Password elements are required. If the
  Group and Username elements are missing, they are assumed to be
  empty.  All other fields or elements can be present but will be ignored.
[] Add highlighting of added/changed and deleted records.  The latter can
seen via View->Show Changed Entries.

Changes to Existing Features in 3.20
====================================
[2880663] 'Browse to' special fields (currently: [alt], {alt}, [ssh], [autotype]
and [xa]) are removed from the URL field when copied to the clipboard or when
used in the RunCommand (via $url).  If the '[alt]' or {alt} were present, then
the RunCommand will execute this program.
[2868278] The SystemTray Unlock menu item now only unlocks the
database (when correct passphrase is provided). To show the
application's main window, use the Restore menu item.
[2874520] To prevent junk showing in the Notes field in List View due
to end of line characters, now only show the first line but indicate
more are there using [>>>] at end of line. Setting preference "Show
Notes as Tooltips in Tree & List View" will show these (up to 250 characters).

Bugs fixed in 3.19
==================
[2865116] Status-Bar message now correctly states "Password Copied"
when doing a "Run Command".
[2865116] Status-Bar message now updated when using the keyboard arrows
to transverse entries in Tree and List views.
[2856750] The Password Policy now correctly displayed in List View,
when selected.
[2856051] Changes to database preferences are no longer lost upon minimize.
[2856410] The "Run Command" menu entry is no longer greyed out for
Shortcuts to base entries with a Run Command.
[2851848] Mouse double-click interval removed from Virtual Keyboard
to allow multiple virtual keys to be entered quickly.
[2850907] Password field no longer cleared after focus change.
[2842700] No longer crashes when using a French keyboard.
[2192490, 2840534] Multiple desktops now handled correctly for Windows
XP and later system.
[2836569] Correct password data now copied from Edit dialog using
'Smart Labels'
[2832991] Double-click action display in the Status Bar now shows
correct value for entries that have overridden the current default.
[2820260] Fix password expiry interval processing during Edit.
[2818653] Password expiry interval now correctly exported to XML and
displayed during Edit, if present.
[2813295] 'Browse + Autotype' system tray menu items fixed - thanks to
Vasily for reporting and sending the patches for this.
[2085058] Old (1.x) format databases now closed correctly.
[] Fixed problem with viewing a shortcut in read-only mode - thanks to
gillum for reporting and helping track this down.
[] Fix crash when using External Editor on Notes field.
[] Password verification field not set when editing/viewing an alias entry
and the password is hidden.
[] Enter key works again in initial dialog if browse button used to
select a database. 
[] AutoType by an alias now has correct password and its own notes data
rather than '[Alias]' and its base's notes data, respectively.
[] Run command no longer truncates the first field if it is within double
quotes.
[] Duplicate entry now duplicates double-click action of original as well.
[] Double-click on a shortcut entry now executes the action of its base.
[] Drag & Drop of entries with explicit double-click action values
between different databases now works. 
[] Browse to URL from an Alias entry now puts the correct password in the
clipboard.
[] Text import no longer overwrites entry's RunCommand with
double-click action value.
[] Tidy up item order in Edit menu and right-click context menu.

New Features for 3.19
=====================
[2832983] The Edit/View dialog now shows the details of the entry
being edited/viewed in its title caption (This is updated when saving
the entry).
[2832810] A new email field has been added, supporting email headers
'to', 'subject', 'cc', 'bcc' and 'body' (per RFC 2368 - see online
help for details). If this field is not empty, it is used instead of
the URL field even if that contains an email address.
Note: whereas the URL field had to have the 'mailto:' prefix to denote an 
email address rather than a URL, the email field must not contain this prefix.
[] PasswordSafe now handles Vista (and later) logoff, shutdown &
restart more gracefully, giving the user now has more time to save a
modified database.
[] Add new AutoType special fields '\wnnn' and '\Wnnn'. Unlike '\d', which
sets the delay between sending each subsequent character, '\w' & '\W'
introduces a one-time delay where they appear.  For '\w', the value 'nnn' is in
milli-seconds. For '\W', this specifies seconds. Note: Max. value is
999s (16m 39s), during which time PasswordSafe will be unresponsive
while it waits the specified time. Also supported via the Run Command
$a command.
[] Add menu item to copy the Run Command to the clipboard.
[] Support Run Command and Double-Click Action (and email) fields in Filters.

Changes to Existing Features in 3.19
====================================
[] Changing the Security option to lock Password Safe when the workstation is
locked, no longer requires a restart of Password Safe to come into effect.
[] Due to the French keyboard not supporting the key '-' in an accelerator,
the shortcut for "Password Subset" has been changed from "Ctrl + -" to
"Ctrl + B". Please do not allocate "Ctrl + -" to any shortcut if you will be
using a French keyboard.
[] If a dialog is open (e.g. Add, Edit, Options etc.) and Password Safe is
minimized, the Close and Exit options are no longer in the System Tray context
menu. The user must first Restore the application and close the dialog before
being able to close the database or exit the program.
[] If preferences stored in the database are changed, the user will be asked if
they want to save them in the database when closing the database or application
even if none of the entries have been changed.
[] The preference to Lock the Database after a certain amount of idle time has
changed from being a global parameter affecting all databases opened by the user
to be specific to each database.

New Features for 3.18.1
=======================
[] Add minidump support for release builds so that we can try to solve
issues with more information than Windows normally provides.

New Features for 3.18.1
=======================
[2793283] Allow entry to override doubleclick setting.
[2793280] Browse+Autotype added to configurable double click actions.
[] Implement Virtual Keyboards for multilingual passphrase entry.
[] DragBar now has ToolTips to inform user of its use.
[] User can close the currently open database via the System Tray
menu.
[] Improved Merge reporting.

Changes to Existing Features in 3.18.1
======================================
[] New toolbar icon set has been replaced with icons based on famfamfam's
silk set.
[] Reworked Add and Edit dialogs into Property Pages.

Bugs fixed in 3.18
==================
[2795428] Browse+ on Toolbar now inactive if no URL present
[2795427] Duplicate of "Display Subset of Password" removed from Context
Menu (right-click on entry).
[2789873] Status bar now updated properly after Browse to URL and other
actions that copied data to the clipboard.
[2782413] No longer crashes when loading 0302 formatted headers (from
~v3.08).
[2779705] Reserved shortcuts (Ctrl+Q, Alt+F4 and F1) now work.
[] Run Command now correctly copied via Drag & Drop.
[] Allow all fields to be selected for Compare function.
[] Fixed crash if renaming an entry to one that already exists.

Bugs fixed in 3.17
==================
[2750090] Using SaveAs now unlocks original database on successful
completion of the save.
[2689144] PWS no longer goes into a loop if the main menu has not yet
been displayed when accessing the recent entries via the system tray icon.
[2664657] Installer now prompts for elevation to administrator rights
on Windows Vista.
[2664703] Load base locale DLL if can't find a specific sub-locale version.
[2657132] View Reports no longer causes application crash.
[] Correct DragBar bitmaps for a new database.

Changes to Existing Features in 3.17
====================================
[] When doing a Browse to URL, the password of the current entry is
copied to the clipboard. This is action is not performed if the Browse
is invoked from the Edit dialog box.
[] Shortcut 'Ctrl+B' (Manage Menu->Backup) has been removed. Shortcut
'Ctrl+R' (Manage Menu->Restore) has been re-assigned to the new "Run
Command" function.

New Features for 3.17
=====================
[1954166] New preference to control word wrap in the Notes field in
Add & Edit. This can be overridden for a specific entry by
right-clicking in the Notes field.
[1533621, 1722481] There's a new, "Browse+" action that combines
browsing to an entry's URL and entering the username, password,
etc. in a single operation. Note that this does not work (yet) for all
browsers and all sites. See help for details.
[1405326] Add new field 'Run Command' to allow arbitrary commands,
such as terminal emulators, etc. to be executed via Ctrl+R or from the
Edit menu. See help for details. 
[] Implement "Find Up" via clicking Find toolbar button with Shift key down
or pressing 'Shift+F3' for repeat find up.
[] Allow users to set their own shortcut keys for menu items. Select via
Manage->Options->Shortcuts.

Bugs fixed in 3.16.1
====================
[2599930] All fields, buttons, checkboxes that could change an entry's
data are disabled if the database is in read-only mode.
[] Lock on Windows Lock works again.
[] Ctrl+F sets focus to the find string edit box.
[] No longers asks for confirmation of Cancel during Edit in read only
mode as that is the only option available to the user.
[] Right-click context menu now correct when user hides toolbars.

Bugs fixed in 3.16
==================
[2529736] Validate now corrects all Password History errors.
[2509817] Control characters no longer sent via Autotype.
[2481370] Can now create shortcut by right-mouse down dragging.
[2423397] Sorting direction database preference was not being saved in
the database.  See "Changes to Existing Features" below.
[] Can now process filters (within the database or imported) based on
'username' field ("user" in the XML file).

Changes to Existing Features in 3.16
=======================================
[2423397] Changes to preferences stored in the database are no longer
silently saved in the database (including any changes to any entries).
A new flag is shown in the Status Bar to indicate the preferences have
been changed and the user can decide to save these, or not, when closing
the database, directly or when ending the application.
[Open Discussion] Ctrl+F no longer toggles the Find Toolbar but shows
it if not currently visible.
[] Support interoperability with tools that access edit control text
by setting PWS_PW_MODE environment variable to "NORMAL".

New Features for 3.16
========================
[2509821] Support Group (\g), Title (\i) and Notes (\o, \onnn) fields
via Autotype.
[2450841] The user can use the DragBar to drag and drop the group name
when a group is selected. Pressing the Ctrl key while dragging the group,
when a group or entry is selected, will only copy the immediate parent group.
Standard behaviour is to copy all groups up to the root of the database with
dots between successive group names.
[2450827] Add a new menu item (on Edit Menu or right-click context
menu) to go to the corresponding base entry of an Alias or Shortcut. As
part of this change, only relevant items are shown on the Edit menu depending
on the current selected item (group or normal, shortcut base, alias base,
alias or shortcut entry).
[2425045] During Edit, if the entry has been changed and the user presses
the Cancel button, they are asked to confirm losing their changes.
[2415952] The current display status of the Find Toolbar is remembered at
application close and, if visible, it is will be shown the next time the
application is started.
[] Installation program now offers German as well as English
installation instructions, as well as installing German language
support. The framework is easily extended to other languages. Thanks
to Karlo Van der Gucht for his work on this.

Bugs fixed in 3.15
==================
[2407346] "Open Another" and "Create New" actions in "Incorrect
Passkey" dialog box working again.
[2407325] Prevent creation of a group name with '.', which confuses
PasswordSafe.
[2407072] Can now tab to read-only checkbox in password entry form via
File->Open or recently used list.
[2269930] Track write permission of file in opening dialog: If the
user chooses a file with different permission than the original, then
the r-o status is updated accordingly.
[2142691] Better support for Japanese text.
[2113261] No longer crashes when opening write-protected database.
[2102624] Can now change a normal entry into an alias or an alias'
base entry into an alias of another entry taking its aliases with it.
[2101656] Incorrect Notes field behaviour when using scroll bars 
corrected.
[2100916] Correct colouring of the Dragbar icons after changing
selected entry.
[2100429] Handle invalid time field in database gracefully. Thanks to
David B. Martin for his help in tracking this down.
[1958728] More graceful handling of corrupt databases - avoid "out of
memory" failures. Thanks to Serkan Kenar for his help on this.
[] Correct display of tree items on restore from minimize when 'X'
button used to minimize.
[] Ensure XML Import correctly processes normal entries with a 
password field that is in alias or shortcut form.

Changes to Existing Features in 3.15
====================================
None.

New Features for 3.15
=====================
[2203438] Remove "[alt]", "[ssh]" and "{alt}" special keywords from URL
when copying to the clipboard.
[2144489] Click on the text next to edit fields to copy the field to
the clipboard. Ctrl+Click on the URL will launch the browser. Text will
flash to show what it has done (green - copy, pink - launch).
[1871364] Add feature to display a subset of the password. This is useful
for websites that need different particular characters from a password at
each login. To access this, select an item, right-click and choose
Display Subset of Password.  This can also be added to the user's toolbar.
[] Implement the CF_CLIPBOARD_VIEWER_IGNORE feature supported by some
Clipboard Viewers.

Bugs fixed in 3.14.01
=====================
[2096504] All user set fields are now checked when merging databases.
[2096164] -h, -u and -g command line functionality restored.
[2088540] Showing Dragbar is now independent of displaying the
Toolbar.
[2085103] New database can no longer be created as R/O.
[2085089] Database field in "Safe combination Entry" dialog no longer
loses focus to passphrase field after each character change.

Bugs fixed in 3.14
==================
[2071489] off-by-one bug in range for generated passwords fixed.
[1978486] The R/W status of a database is unchanged if it is already 
open and the user cancels an open file action.
[1978475] Clear clipboard options are no longer interchanged.
[1970652] No longer crashes when user exits search for non-existant
database.
[1966718] Text in 'Notes" now has horizontal scroll bar during Add.
[1959193] PWS now honors the read-only command line parameter (-r)
for first file open. Afterwards, the behavior is determined by the R/O
open preference or user selecting read-only at open time.
[1954268] Aliases and shortcuts now processed correctly during merge.
[1933174, 2015132] Reports from Import (Text or XML), Compare, Merge
and Find are no longer written to disk by default.
[] Expired icon now correct after password change.
[] Current tree state is now updated correctly upon exit (Thanks to
Norman)
[] Correct display of tree items on restore from minimize.

Changes to Existing Features in 3.14
====================================
[1958303] TreeView buttons (+/-) now larger without significantly
increasing the visible bitmap image.  Also, now transparent.
[] Drop down list of databases at start-up now retains order of usage
rather than sorted alphabetically.
[] A new Double-click action has been added: Copy password to
clipboard and then minimize. Thanks to Garrett for his work on this.

New Features for 3.14
=====================
[2004500] CTRL-A now selects all of the Notes field in Add & Edit.
[1817880, 2018365] Option to allow restricting only a single instance per user.
If set and another copy of PasswordSafe started, focus is given to the
existing instance.
[] The entries displayed can now be filtered based on rules on every
field in the database.
[] Add Dragbar and also allow D&D from Tree onto a text field to drop the
entry's password value.
[] During initial open, tooltips in the drop down list box will display 
the full database names and paths.

Bugs fixed in 3.13
==================
[1941360] Rename with F2 now enables Save button.
[1940311] Password Policy now ignores length requirements if not applicable.
[1938057] Non-Latin text now correctly exported to plain text file.
[1926678, 1937293,1939294] Reduce GDI object leaks that cause display problems
during hibernation, screen locking and remote access.
[1914433] It is now possible to view the password policy set for an
individual entry, by shift-clicking on the checked Override Policy
checkbox. A tooltip explaining this is shown when relevant.
[1904391] Many functions, e.g.,  cancelling a rename of an entry,
inter-instance Drag & Drop, no longer collapse the entire tree.
[1904254] Non-text fields (e.g., time) are not shown in Advanced
Search, as they are not searched.
[1900655] Compare advanced subset now applies to current and comparison
databases.
[1899876] Fixed title/user problem when opening v1.7 databases.
[1598836] Correct treeview now displayed after restore from timeout lock.
[1478022] Correct description of this fix in the Release Notes to avoid
user confusion thinking it does something different.
[] Ensure first entry is selected when opening an existing database.
[] XML export of password history fixed for when number to be saved > 99.
[] Fix incorrect lock file handling during SaveAs.

Changes to Existing Features in 3.13
====================================
[] Improved compare database reporting.
[] Copying an empty field to the clipboard now emptied the clipboard
(previously, no action was performed).

New Features for 3.13
=====================
[1914644] Password expiry can now be set as an (optionally repeating)
interval. This is indicated in the List view by an asterisk after the 
expiry date.
[1904254] Find now searches all text fields by default.
[1901380] Find result highlighted and selected.
[1901380] If the Esc key is not being used to minimize PasswordSafe, then
it will close the Find Toolbar.
[1901380] F3 (Repeat Find) works even if the Find Toolbar has been closed.
[1887159] PasswordSafe may be configured to open databases 'Read-only' by
default.  This can still be overridden during open if the file itself
is not read-only.
[1664535] Interpret "Remember 0 last databases" on the System Options as 
"do not store any opened database".
[1399569, 912188] Separate the clear clipboard options on minimize and exit.
[1207606] Notes may optionally be shown as tooltips.
[988806] The Status Bar now provides Feedback on double click actions.
[] Alt+F4, in addition to Ctrl+Q, now closes the application.
[] Allow user to Hide/Show main toolbar.
[] Ability to create/view a report of the previous Find request.

Bugs fixed in 3.12
==================
[1855658, 1436850] Implement font for password display correctly.
[1850271] Save after Compare no longer corrupts database.
[1849881, 700973] Pressing a character in the List view will now jump to the
next entry with text beginning with that character in the second column. This
is a change from previous behaviour, which only looked in the first column,
now occupied by the icon.
[1849830] Help now works properly for Manage->Option, displaying the
relevant topic.
[1849818] Browse-to no longer falsely reports "failed to browse to
URL".
[1843631] "Browse to Icon" now correctly shown using new Toolbar.
[1841525] Increasing the number of passwords saved no longer deletes the
existing Password History.
[1833609, 1535341, 1502036] Fully support multiple monitors.
[1749268] Mouse clicks on tree view plus/minus boxes now works correctly.
[1670193] Better Vista support (Allow use of Windows Common Controls
V6 with Vista).
[1478022] User must save a restored database before it can be exported.
[1440693] Fix standard keyboard access to context menu (Shift+F10).
[] Allow Expand/Collapse for read-only databases via toolbar.
[] Set focus to new view on switching between Tree <-> List views.
[] Update toolbar when view changes (List <-> Tree).
[] Set title bar text when opening a database at startup.
[] Allow List view to process all characters e.g. Page Up/Down, Home, End,
Arrows etc.
[] Fix program crash on clicking CompareResults dialog header.
[] Toolbar Save button correctly enabled after drag & drop operations.

Changes to Existing Features in 3.12
====================================
[1885710, 1852862] When re-showing the Find toolbar, any existing search
argument is selected to allow easier deletion and modification.
[1865009] Give user advanced option to ignore whitespace-only
differences during compare.
[1846688, 1224373] When generating a new password, it is no longer displayed
in a separate window for approval. If you want to generate another
password, just click on Generate again. If you want to revert to the
existing password when editing an entry, just click on Cancel.
[1841221] During drag & drop, a 1.5 second delay was introduced before
expanding a group that the cursor "hovers" upon.
[] New disabled buttons for New Toolbar.

New Features for 3.12
=====================
[1842449, 1000639] Implement standard F3 for repeat Find shortcut.
[1838738] Implement minimum lengths of types of characters in the
password policy i.e. 3 uppercase + 2 lowercase + 1 digit etc.  Feature
is incompatible with 'pronounceable' or 'easy-to-read' passwords.
[1676241, 1511829, 1436850, 1426250, 1078998, 996240, 771845] Allow
user to select a font for Passwords, so that similar characters can be
distinguished e.g. 0 & O, 1, I & l.
[] Implement individual password policy for entries that will override
the current database policy.  User can still override the individual
policy or the database policy.
[] An entry may have multiple references, or "shortcuts" to it,
similar to Windows' shortcuts. These may be thought of as "synonyms"
of the entry. To create a shortcut, drag an entry with the right mouse
button pressed.
[] Graphics added to menus.
[] New password generation option: Pronounceable passwords. Thanks to
Tom Van Vleck, Morrie Gasser, and Dan Edwards.

Bugs fixed in 3.11.1
====================
[1837534] Autotype handles tab correctly when typing to Internet
Explorer.
[] No longer crashes when pulling down Edit menu in List view with no
entry selected.
[] Copy Username and Copy Password new toolbar icons swapped back.

Changes to Existing Features in 3.11.1
======================================
[] You can now check for newer version via Help->About.
[] List view displays an icon in each row showing the type of entry.

New Features for 3.11
=====================
[1765240] Add "Clear clipboard" item to tray icon context menu.
[1727768] Copy URL to clipboard added to menus (Ctrl+Alt+L).
[1526169] Add more shortcut keys to add/edit dialog.
[] Give user access to Reports from View menu (only in the same directory
as current open database), since more information is being written there.
[] Give user access to the Compare report from the Compare results dialog.
[] New email action allowed in URL field. To be treated as email, the
data must be prefixed by the characters "mailto:". The data following
this corresponds to the '[mailto:]' standard RFC2368.
For example: "info@example.com?subject=PasswordSafe".
[] Main toolbar can be customized via MS's standard dialog via right
click on this toolbar.
[] Several entries may be "aliased" to a single entry, sharing its
password. See online help for details.

Changes to Existing Features in 3.11
====================================
[1815192] The Find function has been re-implemented as a toolbar at
bottom of application.
Button shortcuts: Ctrl+Alt+A = Advanced find,
Ctrl+Alt+S = toggle case Sensitivity, Ctrl+Alt+C = Clear find text
[1790342] Replaced additional key shortcuts for ExpandAll and CollapseAll
[introduced in rev. 1678] by toolbar buttons.  Now there is only one set
(the original) of key shortcuts + toolbar buttons.
[1756385] The color of the application's system tray icon (when the
application is started and when there's no open database) is now user
configurable, fixing a visibility problem under Vista.
[] Saved string preferences within the database header will not be delimited by
a double quote if this character is part of the string variable.  An arbitrary
symbol type character will be used in this case.  If one cannot be found, the
string preference will not be saved in the database.

Bugs fixed in 3.11
==================
[1806201] Non-unique UUIDs in database now handled correctly.
[1799523] Fix PWS taking a long time saving after XML Import into new DB by
using an extremely large number of hash iterations.  Users who have imported
XML into a new database should export again and re-import after deleting the
<NumberHashIterations>...</NumberHashIterations> entry from the XML file.
[1798588] Users can now change an entry's password with passwords hidden.
[1793224] Copy for expired passwords no longer causes PWS crashes.
[1791482] All preferences stored within the database are now exported/imported
via XML.
[1790286] All String preferences stored within the database are now
correctly read during database open.
[1789983] List View now correct after Group removed.
[1726181] Save of a new database is no longer required to export entries.
[1664219] Autotype now works correctly with '@' in German keyboards,
and non-English keyboards in general.
[1313440] Can new add/edit entries with long group names.
[] Prevent mixed Unicode/ASCII report files and ensure Unicode reports
have BOM as some text editors insist!
[] Disable Rename menu item in List View (only appropriate in Tree View).
[] Disable Tray Minimize/Restore menu items if already Minimized/Visible.
[] Ignore mouse right click not in Tree/List view area.
[] Use the Confirm Delete message even when there is only one child.

New Features for 3.10
=====================
[1752896] Add ability to edit an entry's notes field using user's default
text editor via right click on Notes field.
[1751484] Errors detected while merging or importing a text file are
now described in detail in a log file.
[1750010] Drag&Drop between databases now supported.
[1517048] PasswordSafe can now be installed as an msi package (Windows
installer). This allows site administrators to 'push' PasswordSafe to
client machines with group policy. Thanks to xenophonf.

Changes to Existing Features in 3.10
====================================
None

Bugs fixed in 3.10
==================
[1783905] Read-only status maintained after unlocking a database.
[1782407] Export to text file now includes "title", if selected.
[1774428, 1757298, 1609474] Merge no longer loses data.
[1771357] Timeout timer now reset in all dialog boxes - PasswordSafe
will no longer minimize in the middle of work with an open dialog box.
[1768822] Manage->Options->Password History 'apply' works again.
[1759364, 1758025] '-s' option now works correctly.
[1757110] Toolbar now correctly disables images according to type of entry
selected and if URL is populated.
[1754611, 1754054, 1740704] Items are now fully sorted when "put groups first
in display tree" selected.
[1754566] State of tree view is now persistent across minimize, lock &
save.
[1751465] Fields containing only whitespace or whitespace between double quotes
are now treated as empty during plain text import.
[1734220] XML Export line of Notes fields containing CRLF now works correctly.
The default delimiter has been made the same as for Export to a Text file.
[1632634] Compare no longer changes database settings when the databases are
identical.
[] Window's position and size now updated correctly.
[] Lock timeout after manual lock no longer saves empty database.
[] Ensure group/title/user combination is unique during text import.
[] During Add/Edit, fields containing only whitespace characters (space,
horizontal tab, vertical tab, carriage return, new line and form feed) are
considered empty fields.

New Features for 3.09
=====================
[1751451] Add extra warning when deleting entire group, including the
number of entries that will be deleted.
[1739979] Add URL column to flattened list.
[1732198] It's now possible to override the username and hostname used
to load and store preferences, as well as specify an alternate
preferences file, via new command line options.
[] Implement "Advanced" option for Find.

Changes to Existing Features in 3.09
====================================
[1732163] Date/time displayed throughout in the users "Short Date" format.

Bugs fixed in 3.09
==================
[1754189, 1620423] Focus on search text in Find Dialog - thank to zcecil for
the fix for this one.
[1752318] Fixed duplicate/mislabelled columns problem in list view.
[1748665] Number of passwords to remember (password history) can now
be set to more than 99 by typing rather than only by spin box.
[1743706] Fix random showing of user and passwords if started in
silent mode.
[1741787, 1728945] Version 2.x databases now read correctly.
[1739364] Window location issue fixed.
[1738477, 1630400] A version for Windows98 is now installed by the
installer on machines running Windows98. This version is NOT part of
the binaries in the zip file.
[1733911] File mode encryption/decryption (-d/-e) works again.
[1733740] '-s' option no longer causes sporadic display of passwords
in tree view.
[1735290] Configuration file works with non-ASCII user and host names.
[1728945] Importing a subset of text data now fixed.
[1728612] Column sort arrows, in Flattened List mode, correctly removed.
[1727871] Found items remain highlighted if another entry selected -
note that found items now displayed in bold font rather than
highlighted.
[] A note on possible problems with the autotype functionality and
some 3rd party popup-blockers. Thanks to mrttoo for the heads-up.
[] Protect user from losing entries in case of non-unique UUIDs in
read database.
[] Compare fixed so that 'X' indicating differences are in the correct
columns and data copied to clipboard ends in CRLF not just LF.
[] The installer will detect and notify the user if attempts to
install on an unsupported version of Windows (95 & ME).
[] Fix Edit and View in main menu not being reset after open after close.

New Features for 3.08
=====================
[1711524] "Show username in display tree" display option.
[1695968] "Advanced" option now available to improve Merge operation.
[1695446] It's possible to specify command line parameters for
Alternate Browser; e.g. "-new-tab" for Firefox. This allows fine
control of whether or not to open a new browser or not.
[] Implement "Advanced" option for Exporting in XML format (as per
Export in Text format) and for when comparing databases.
[] Maintain unknown fields in the database header and records when
saving database, for compatibility with future versions as well as clones.

Changes to Existing Features in 3.08
====================================
None

Bugs fixed in 3.08
==================
[1723936] Expiry date format is now in the user's Short Date format.
[1721031] Notes field with lots of text now stays in position when focus lost.
[1721009] Can now Import into a new database after closing previous database.
[1709992, 1692662, 1678711, 1651392, 1626671, 1604806] Non-English
text in databases fully supported.
[1709418] Cancel after Lock Safe from system tray now does Right Thing.
[1708099] Default saved username, now shows in new entry.
[1702623] Compare now shows correct filenames.
[1701508] Entry times no longer written out if not set.
[1695991] File type Compare now has .bak & .ibak suffixes.
[1693395] Now Minimize takes precedence over "Always on Top" during Autotype.
[1691048] Import text file with blank lines or missing fields will no
longer crash application.
[1688994] Although rename is not possible in read-only mode, this change
prevents F2 giving the user the feel that they can.
[1678527] Line delimiter now works during import of plain text.
[Open Discussion] Allow Notes field to be Imported from text file even if
it is not enclosed in double quotes.
[Open Discussion] Fix issue if PWS is maximized/minimized/then restored.
[] Fix problem with remembering Tree state on restore after minimize.
[] More stringent checking during tree "edit in-place" to prevent DB corruption.

New Features for 3.07
=====================
[1686819] - PWS may be configured not to minimize during Autotype
(Manage->Options->Misc). 'Always on Top' takes precedence.
[1623802] Default Autotype string can be specified per database.
[] - Password expiration notice can now be given a few days prior to
actual expiration.
[] - Exported/imported text format is now documented in online help.
[] If the PWS_PREFSDIR environment variable is defined, that's where
the pwsafe.cfg file will be read from, instead of the same directory
as the executable.

Changes to Existing Features in 3.07
====================================
[] List view columns now selectable, entries sortable by any column,
settings are persistent.
[] List view may be configured to show Grid lines.
[] Tree view may be configured to show all groups first, instead of
strict alphabetic order.

Bugs fixed in 3.07
==================
[1684827, 1668493] No longer crashes after you specify to remember 0 databases.
[1683060] Autotype now works again for all entries.
[1682516] Menu display no longer trashed if accelerator pressed with
an open menu.
[1681366] Now stays on top during autotype.
[1678707] Caps Lock temporarily turned off in Autotype.
[1672770] Right-click->unlock on system tray icon now same as
double-clicking on locked system tray icon.
[1679461, 1612567] Text in Password field no longer truncated with large
texts.
[1675716] <ESC> to close application now works.
[1673028] Merge operation now fixed.
[1673028] Similar problem in Compare operation fixed.
[1660721] Autotype menu & shortcut no longer disabled if field is empty.

New Features for 3.06
=====================
Support for U3 (disk-on-key).

Changes to Existing Features in 3.06
====================================
[1634251] Password expiration date can now be specified relatively,
e.g., "45 days from now".
[] Opening dialog now shows recently opened databases in dropdown list.
[] File opened in initial dialog now added to recent files list.
[] All dates and times are now displayed in the local format.

Bugs fixed in 3.06
==================
[1633516] No longer crashes upon Find with an empty group.
[1625557] No longer crashes when invoking help after using HotKey.
[] Configuration handled correctly with non-English user or host
names.
[] No longer crashes when password history policy changes records.
[] Non-English data issues resolved.

New Features for 3.05.02
========================
None.

Changes to Existing Features in 3.05.02
=======================================
File opened in initial dialog now added to recent files list.

Bugs fixed in 3.05.02
=====================
[1612881, 1577505] Notes now appear consistently.
[1609759] "Show Password in display list & tree" setting now
persistent across application exit.
[1609291, 1606265] No longer terminates after edit when username
and/or hostname starts with a digit.
[1608191] Tree view's state is now preserved across timed lock and
when starting with '-s' flag.

New Features for 3.05
=====================
[1600626] Ability to specify alternate browser for URLs - useful if
Firefox is your default browser, but you need to access a site that
only works with IE, for example.
[1600626, 1504327] Portable (e.g., USB stick) installation supported
(configuration information stored in .cfg file instead of registry).
[1452303, 1303548, 912724] Option to start Password Safe minimized at login.
[1452303] Support multiple automatic backups.

Changes to Existing Features in 3.05
====================================
[838450] The undocumented backup to .psafe3~ has been replaced by the
multiple automatic backup mechanism.

Bugs fixed in 3.05
==================
[1606237*, 1606232*] View preferences now work correctly.
[1606026*] Missing manifest files added, application no longer requires
vcredist_x86.exe
[1605389*] Read-only flag now updated correctly.
[1578171] Hotkey works again if window just obscured.
[1521684,1504527] Old (V1) databases now read correctly - thanks to
Karel Van der Gucht.

New Features for 3.04
=====================
None

Changes to Existing Features in 3.04
====================================
None

Bugs fixed in 3.04
==================
[1575432] Hidden notes no longer lost after edit.
[1575415] Weak master password allowed on password change as well as
new safe.
[1575279] Database now marked as "changed" after performing PWHistory operations.

New Features for 3.03
=====================
[1536006, 1527058] password history - Ability to set the default
number to be saved. Can be overridden on an entry by entry
basis. Changing the default number has no effect if history is already
saved for a particular entry.
[1511833] Better formatting of plain text export files. Only the order of
entries during export has been implemented. Both export to "Plain Text"
and export in "XML Format" will export the database entries in the order
as displayed in the "Nested Tree Mode".
[1302047] Enable Maximize/Window button.
[1249433, 1114473] Startup state for Nested Tree mode - User can now
select startup as a) All groups collapsed (previous behaviour); b) All
groups expanded; or c) Same state as when the database was last saved
(could be either all collapsed, all expanded or a mixture of some
groups expanded and others collapsed).
[] Change Find processing in Tree view so that entries are shown in Tree
order rather than List order.
[] Change Find to stop on the last found item and ask whether to continue
from the beginning of the database or the user may select this previous
behaviour via a Misc. option.
[] New File->Properties shows some information about the database.

Changes to Existing Features in 3.03
====================================
[1532368] Maximum number of passwords stored in history is now 255.
[] Weak master passphrases are accepted, if the user insists.
[] Field with focus has a different color.
[] More info in status bar: read-only and modified status.

Bugs fixed in 3.03
==================
[1557838, 1557559, 1525344, 1523689] Problem with suspend/lock when
edit dialog open resolved.
[1554253] Show/Unhide password no longer loses changes to password.
[1551034] Entries can no longer be changed in read-only mode.
[1540106] Fixed incorrect link to Twofish web page.
[1529305] Crash in Password History resolved.
[1528400] Cancel on "Restore from Backup" no longer corrupts database.
[1527144] No more multiple combination dialogs when restoring window
from system tray.
[1527138] Select after deletion no longer surprises.
[1527029] Password count now displays correctly in status bar.
[1561335, 1373138, 1182406] HotKey now works with SystemTray icon.
[] View Menu item "Collapse All" now works correctly.
[] Double-Click works on entries with expired passwords.

New Features for 3.02
=====================
[1516674] Ability to hide password during Add & Edit entry. If hidden,
password needs to be entered twice to verify.
[1506320] Count of passwords stored in DB on status bar. Also indication
of read/only status.
[1487001, 1120236, 705515] Password history can now be saved for selected
entries.
[] Export/import to/from XML supported.
[] Selective text export.
[] Compare of two databases supported.

Changes to Existing Features in 3.02
====================================
[] Minimum master passphrase length is now 8 characters, and user is
not offered the option of accepting weak passphrases.
[] "Save on minimize" option removed.

Bugs fixed in 3.02
==================
[1526174] Tab order more friendly in Edit dialog box.
[1520562] Single entry is now displayed in Nested Tree Mode.
[1520110, 1503075] No longer crashes when number of last databases is
set to zero.
[1519850] Double-click on group entry in tree did not expand/collapse
group.
[1519227] Password expires date was set wrong.
[1515994] User is now prompted to save database on system shutdown.
[1513482] Preferences now saved in the .psafe3 file.
[1507847] Merge databases now merges all the record's fields, thanks
to n0tig.
[1504107] No longer saves cleared database.
[1503123] Exits cleanly from lock with open dialog box.
[] Tree is now refreshed if user decides not to open another DB.

New Features for 3.01
=====================.
[1465395] View Passwords in Nested Tree Mode
[1162051] Toolbar additions (Autotype, Browse URL, Copy Notes to clipboard)
[726518] User can configure an expiration date for entries and be
notified accordingly.
[726508] Modification and access times now recorded.
[737878] Copy Notes to Clipboard.
[] Ability to clear "Recent Database List".
[] Browse to URL now starts a new instance of the user's default browser
rather than taking over an existing instance.

Changes to Existing Features in 3.01
====================================
None

Bugs fixed in 3.01
==================
[1495670] Find now searches new URL and Autotype fields.
[1495556] Restore after minimize now works when system-tray not used.
[1490985, 1423020, 1398936] Microsoft redistributable DLLs now
included in installation and zip file. Should fix all "MS*.dll not
installed" problems.
[1482002] Generated password no longer trashed if > 127 bytes.
[1472332] Read-only command line argument bug.
[1440951] Can now close application after minimize w/o system tray.
[] Help file now reflects 3.0 new features.

New Features for 3.0Beta2:
==========================
None.

Bugs fixed in 3.0Beta2:
=======================
[1450484] Trailing garbage in tooltip text fixed (DK).
[1462527] Uses a decent PRNG for non-XP platforms, closing key recovery
attack vulnerability.
[1446183] Export to v2 format now readable by pwsafe v2.x
[1463103] Fields in Edit Dialog are wider.
[1450486] URLs without a protocol now default to http.
[1459326, 1427642] Fixed problems with password prompt (DK)

Known problems in 3.0Beta2:
===========================
[1453108] Broken under Windows98SE?

New Features for 3.0Beta1:
==========================
[731841] Database format is changed to use newer encryption algorithm (Twofish
replaces Blowfish). Also, the integrity of the database is now checked.
[] Entry creation time is now stored.
[1393632, 1224370] URL and Autotype moved from Notes to their own fields.
[] System Tray icon now indicated if database is locked or not (Thanks to
DK for this cool feature!)
[1422761] System Tray menu now has a list of recently used entries - a
convenient shortcut to common entries. Thanks to Ork for suggesting this,
and to DK for the implementation!
[] Add and Edit dialog box now have "simple" and "detailed" modes. Thanks
to Dave Collins for implementing this.

Bugs fixed in 3.0Beta1:
=======================
[1384738] Backspace is no longer used instead of dots in the title for the
plaintext import/export format.

Known Problems in 3.0Beta1:
===========================
[] No major problems are known in this release. However, it is a FIRST BETA 
release, and should NOT be used on real databases without backups!
[] Online help has not been updated

New feature for 2.16:
=====================
[] When unlocking a locked database, one now has the option of cancelling
the unlock as well as exiting the application. Thanks to DK for this.
[1414899] - System tray tooltip now reflects the name of the database.

Bugs fixed in 2.16:
===================
[1403533] Now takes "No" for an answer in delete group confirmation.
[1412208] Tab sequence of opening dialog fixed.
[1376566, 1393910] Databases written with early 2.x versions of
PasswordSafe can now be read correctly.
[] Installation kit now adds MFC71.dll if missing.

Bugs fixed in 2.15:
===================
[1363569] No longer crashes when deleting the last item in the last group.
[1381729] No longer crashes when restoring with a database already opened.
[1368198] More explanatory error message when database open fails.
[1312870] Backup filename now updated correctly.

New features for 2.15:
======================
[] Double-clicking on an item can now browse to the URL in the item -
thanks to Laszlo Gombos.

Bugs fixed in 2.14:
===================
[] Correct element is now selected after deletion in tree view.
[] It's now possible to delete a group of items
[1197342] The 'delete' key now works in safe combination dialog box (as
well as other dialog boxes)
[1292385] Default preference is to clear clipboard upon exit/minimize

New features for 2.14:
======================
[1207604] Duplicating an existing entry is now possible via the menus or
Ctrl+D. Thanks to DK.
[] Expand all and collapse all tree entries now supported. Thanks to DK
[] Selecting font for display of entries now supported. Thanks to DK
[] If Window's RtlGenRandom is available, use it instead of rand(). Thanks
to Laurion Burchall.
[] Newly generated passwords are copied to clipboard. Thanks to Laurion
Burchall.

Bugs fixed in 2.13:
===================
[1275880,1275041,1280378] No longer crashes upon unlock if groups were
expanded at lock time.

New Features for 2.13:
======================
None - This release only fixes the abovementioned bug.

Bugs fixed in 2.12:
===================
[1216983] Tree view is now the default view for new users.
[1208955] Autotype now works with Terminal Services Windows and capital
letters.
[1003782,1030077] In tree view, the expanded trees are no longer collapsed
after minimizing/restoring.
[1179342,1237793] Ctrl-L, autotype sometimes used old data
[1004026] No more multiple highlights after doing a "Find Next"
[1214940] Cancel on password entry with system tray no longer clears
entries, allowing potential overwrite of database.
[1217271,1258982] Specifying -r with a filename in command line now works
correctly.

New Features for 2.12:
======================
[1236853] MRU now configurable
[1225255] Double-clicking on an entry can now be configured to Autotype the
entry.

Bugs fixed in 2.11:
===================
[] When system tray is used, close ("X") button no longer exits
application.
[1197706] Delay argument in autotype now correctly parsed (thanks to
dturland for this!)
[1170297, 1076510, 1183709] Clipboard is cleared upon exit from system
tray, if it still contains data from application.
[1207701] During Import, groups are no longer created under an empty
group. (*)
[1095881] Entries with titles containing a dot no longer cause Import to
treat them as nested groups. (*)
[] SetPasswordFont in request for password during Export. (*)
[1207600] Find dialog not moved off-screen if PasswordSafe takes up whole
screen.

New Features for 2.11:
======================
[1162651, 1203679] '-r' may now be passed a command line switch, setting the
'read-only' checkbox. Useful if user wants this to be the default.
[] Export to plain text of entries with multi-line notes fields now can be
kept on a single line (aids editing & sorting). (*)
[] Import from plain text support for single line "multi-line" notes fields
created above. (*)

(*) Thanks to DK for his work on these bug fixes and new features!

Bugs fixed in 2.10:
===================
[1123373, 1075046] Uninstall will only remove installed files, and
will delete the installation directory if and only if it's empty.
[1151575, 1151581] Don't try to unlock empty filename in OnDestroy
(ASSERT failed in debug version - potential problem in release
version)
[1076377] Entering the wrong password 3 times no longer allows you to
create an empty database with the same name.
[1108115] "Cancel" at "Safe Combination Entry" no longer opens blank
database with name of existing database.
[1145173, 947813] Main window will be visible even if resolution
changes or multiple screens used between invocations.
[1145747] The import delimiter is now changeable (Thanks to Roger
Hakansson for the patch).
[1162044] URL "Browse to" feature now documented.
[1165681] Lock file now deleted if user cancels in unlock dialog box.
[1170180] Status bar now shows correct text.

New Features for 2.10:
======================
[1078901] Ctrl+L is now a shortcut for "Browse to URL".
[1162048, 726521] Hotkey restore: A selectable hotkey combination will restore
PasswordSafe from the system tray, if minimized, or bring it to the
front, if obscured by other applications.

Bugs fixed in 2.09:
===================
[1107971] Edit via double-click no longer crashes the application.
[1103501,1119212,1138635] Refined file lock mechanism.

New Features for 2.09:
======================
When saving a database, the previous version, if one exists, will be
renamed with the ".dat~" suffix. This provides some minimal automatic
backup.

Bugs fixed in 2.08:
===================
[1077638] The size of the help file was reduced by using graphics
with fewer colors.
[1082510] Improvements to Find dialog: No longer obscures parent, last
searched text remembered.
[1090153] Pressing Delete in Find dialog no longer deletes an entry.
[1074014] Silly message no longer displayed upon drag&drop of a file
onto main window.

New Features for 2.08:
======================
[1094005,1083950] Multiple instances of PasswordSafe can now open the same
database - only the first instance will be able to modify the database,
unless explicitly opened read-only.

Bugs fixed in 2.07:
===================
[1043438] Idle time lockout now works for idle times other than one
minute.
[1060241] Changing preference with no database opened no longer pops
up error message.
[1006234] Choosing "Cancel" in the Enter Password dialog box now exits
the application.
[1065049] Fixed broken link to Blowfish algorithm reference in Help.
[1021879] Enter on a tree-item expands/collapses the list under that
item.
[1055968,1030060] Import text now handles Notes that are more than one
line long (as long as the entire note is "within double quotes").

New Features for 2.07:
======================
[885984,722646] It is now possible to merge two different databases (File->Merge)
[1055961, 1030775, 947841] The action taken upon double-clicking an
entry can now be configured (via Manage->Misc): Either copy the
password to the clipboard or edit/view the entry.
[] The Import from text function is now more flexible: the field
separator can be configured, and the imported entries may be under a
common group or not.
[] It is now possible to import text files exported by KeePass.
[] The English online help file has been rewritten.

Known Problems:
===============
[879400] A category cannot be dragged to the top level. Workaround:
Edit the Group field of the categories entries. For example, to make
category "b" a top level category instead of under "a", change all
its entries Group fields from "a.b" to "b".

Bugs fixed in 2.06:
===================
[1026630] Autotype now works correctly when "lock database on
minimize" active.
[1028394] Export to text function works again.
[1003780, 1026335] Autotype support for AltGr
[1039214, 992178] PasswordSafe can now be configured to ignore the Esc
key or to exit when it is pressed (Manage->Options->Misc).

New Features for 2.06:
======================
[958343] PasswordSafe can now be configured to lock automatically
after a predefined idle time.
[998966] In an "autotype" string, \d followed by up to 3 digits will
cause the program to pause that many milliseconds between characters
from that moment onwards.
[1032149] Adding an entry with a group or item selected will fill the
Group field with that currently selected (previously, this only worked
on right-click on group item).

Bugs fixed in 2.05:
===================
[1007283] Database no longer accidentally erased if modified and then
screen lock kicks in before save.
[1022367] Screen lock is disabled if a dialog box is open, such as
when editing an exiting entry, adding an entry, etc.
[992178] ESC no longer exits the application.
[998745, 1003780] Autotype feature now works for non-US keyboards
[987618] The group field of an entry is now also taken into account
when checking for uniqueness.

New Features for 2.05:
======================
[917795, 995167] Import from plain text file supported
[951317, 894466, 834197] Preferences stored in password database as
well as registry - useful for users who access the same database on
several computers.

Bugs fixed in 2.04:
===================
[970036] 24 bit displays now display toolbar correctly
[971114] Switch to list view now works with new toolbar (silly typo in
2.03)
[972460] Master password is no longer kept in memory in the clear
[899400, 899414] Drag & drop is now accurate
[864828] Icon should now be visible in taskbar on all versions of
Windows and all color schemes.
[992073] Double clicking a group icon now does the right thing, i.e.,
nothing
[899412] Editing group names is now easier: Can now be invoked via F2
and right-click, finished by Enter, and cancelled by Escape.
[871471] Key shortcuts for Yes/No added to several dialog boxes.
[986874] "Ooops" message no longer appears upon invoking Browse to URL
[unreported] PasswordSafe now compiles cleanly under Visual Studio
.NET as well a Visual Studio 6.0

New Features for 2.04:
======================
[851563, 654677] Minimize to System Tray now supported. This is a configurable
feature, active by default. Clearing the checkbox in
Manage->Options->Display will restore the old behaviour.
[986345] The popup menu for entries now displays the more frequently
used operations (copy username & password) first.
[unreported] There's a new "lock on workstation lock" option in
Manage->Options->Security
[969038] Autotype feature added: This is a really nice feature that
pastes the selected entry's information (by default, username, tab,
password, tab, enter) to the current browser field. See the online
help for more details (See Autotype under "PasswordSafe Overview").
[978070] Search (Find) function is now better documented.

Bugs fixed in 2.03:
===================
[940585] On Windows XP, the toolbar would sometimes be invisible with
the tree view active.
[957957, 900331] No longer crashes when deleting certain items in tree view.

New Features for 2.03:
======================
[847769] An "installer" version is now available! Thanks to David Lacy
Kusters and Andrew Mill.
[912799, 947146] If the display supports more than 256 colors, the user can choose
between two styles of toolbar icons via the View menu. If not, then
only the simple toolbar is enabled.
[940000] The Notes section now has a scrollbar, making it easier to
view long notes entries.

Bugs fixed in 2.02:
===================
[931119, 934192, 938393] No longer crashes when trying to change
master password ("combination") - bug introduced in 2.01

New Features for 2.02:
======================
[789030, 932445] It's now possible to override the random password
generation policy for a single password in the add and edit entry dialog boxes.

Bugs fixed in 2.01:
===================
[902003, 905449] No longer crashes when last item is deleted.
[923401] Combination (master password) wasn't checked for mixed-case.
[917525] Right click when cursor isn't over an now entry handled
correctly.
[912293, 916587] Can now invoke edit dialog after in-line edit of tree-view
entry. (also, no longer crashes upon delete of edited item)
[912751] If the last database saved is no longer available, ask the
user what to do, rather than force the creation of a new one.
[908335, 913684] Icon display problem on XP fixed, thanks to Mike Batten.
[xxxxxx] On XP, password no longer appears with vertical bars, thanks
to DK.

New Features for 2.01:
======================
[921859] URLs starting with "ftp://" are also right-clickable.
[xxxxxx] Now possible to specify hexadecimal password generation in
Manage->Options->Password Policy, thanks ot DK.

New Features for 2.0:
=====================
Two major new features in this release: A new database format, and a
new tree view. The former should be invisible to users, the latter
quite useful.

The application imports old database files transparently, and warns
the user upon saving that the new format is incompatible with old
versions of the program.

Also, the first URL in the Notes field (starting with http: or https:)
will be added to the popup (right-click) menu for that entry. 
Selecting it will invoke the default browser on that URL.

A Russian version of the help file may be found in
http://passwordsafe.sourceforge.net/pwsaferu.zip (Thanks to Maxim 
Tikhonov). If anyone is interested in doing such work in other
languages, please let me  know.

Finally, the graphics have been spruced up a bit - thanks to Emilijan
Mirceski for his patient work on the new logo and toolbar!

Bugs Fixed in 2.0:
==================
[871893] Saving a converted (from old format) database second time now
succeeds.
[875288,893513] Change safe combination works again.
[unreported] Find now selects items in tree view as well as list view.
[878768] Online help updated and functional.
[870756,886601] On XP, data would be invisible until minimize/maximize.
[862504,878768] The help file now works and is updated.
[895062,871893] Multiple saves after editing a converted (from old
format) database now work correctly.
[821837,777937] PasswordSafe is visible in taskbar and task switcher
even when only the login window is displayed.

New Features for 2.0pre2:
=========================
[RFE 504086] It is now possible to export the password database into a
plain ASCII file. Fields are separated by a tab character. Note that
this is a VERY large security risk if used carelessly.


Bugs Fixed in 2.0pre2:
======================
[859798, 859565] Debug libraries are no longer required.

- Export to v1.7 format fixed.

[777937] Safe combination dialog box now appears in taskbar and
switcher

New Features for 2.0pre1:
=========================
[RFE 782508, 829563, 815350, 555440] Tree, or hierarchical, view of
entries now supported. This allows the user to define categories,
sub-categories, etc.

